/* $Id: builtin.h,v 1.14 2004/05/19 03:28:53 yusuke Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */

///  <ID>$Id: builtin.h,v 1.14 2004/05/19 03:28:53 yusuke Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name> builtin.h </name>
///  <overview>
///  <jpn>Ȥ߹߽Ҹ</jpn>
///  </overview>
///

/// <notiondef>
/// <name> builtin_overview </name>
/// <title> builtin롼 </title>
/// 
/// <desc>
/// Ȥ߹߽Ҹ䡢C++Ȥ߹߽ҸȤ˻ѤޥƤޤ
/// </p>
/// </desc>
/// </notiondef>

#ifndef __builtin_h
#define __builtin_h 

#include "lconfig.h"
#include "ftype.h"
#include "initial.h"
#include "proc.h"
#include "machine.h"
#include "structur.h"

namespace lilfes {

const int MAXARGS = 32;

#define dummyturbo(X) X

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_list </name><overview>list,cons,nilɽѿ </overview>
/// <desc><jpn>
/// <p>
/// lilfesǥꥹȹ¤ɽΤ˻Ȥ뷿Ǥ<BR>
/// ؤϰʲΤ褦ˤʤäƤޤ
/// <pre>
/// (cons hd\ tl\)   nil
///  |                |
///  ------------------
///           |
///         t_list
///           |
///          bot
/// </pre>
/// consϡhd\tl\ޤ
/// 1ĤconsꥹȤ1ĤǤбhd\ˤϤǤͤtl\ˤϼ(üʤconsüʤnil)򼨤ޤ

/// 㤨Хꥹ[1,2,3]ϼΤ褦ɽޤ
/// <pre>
/// cons     -> cons     -> cons     -> nil
///  hd\ 1   |   hd\ 2   |   hd\ 3   |
///  tl\ ----    tl\ ----    tl\ ----
/// </pre>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_list, * cons, * nil;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> hd </name><overview>head,tailɽѿ </overview>
/// <desc><jpn>
/// <p>
/// head,tailɽѿǤ<ref>t_list</ref>򻲾ȤƤ
/// </p>
/// </jpn></desc>
/// <body>
extern const feature * hd, * tl;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_cut </name><overview>"!"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// åȷɽѿǤLiLFeSץη"!"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_cut;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_equal </name><overview>"="ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "="ɽѿǤLiLFeSץη"="бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_equal;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_means </name><overview>":-"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ":-"ɽѿǤLiLFeSץη":-"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_means;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_query </name><overview>"?-"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "?-"ɽѿǤLiLFeSץη"?-"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_query;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_not </name><overview>"\+"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "\+"ɽѿǤLiLFeSץη"\+"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_not;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_notuni </name><overview>"\="ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "\="ɽѿǤLiLFeSץη"\="бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_notuni;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_defclause </name><overview>"defclause"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "defclause"ɽѿǤLiLFeSץη"defclause"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_defclause;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> pred </name><overview> Ҹsupertype </overview>
/// <desc><jpn>
/// <p>
/// ٤ƤνҸsupertypeȤʤ뷿Ǥ
/// predsubtypeȤ<ref>t_pred[MAXARGS]</ref>¸ߤޤ
/// ºݤˤϰοȤt_pred[i] (iϰο)subtypeȤƳƽҸޤ
/// </p>
/// </jpn></desc>
/// <body>
extern       type * pred;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_pred[MAXARGS] </name><overview> οȤ˽Ҹ췿ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// <ref>pred</ref>subtypeǤ<BR>
/// 򣱤ĤȤҸt_pred[1],򣲤ĤȤҸt_pred[2]subtypeˤʤޤ
/// </p>
/// </jpn></desc>
/// <body>
extern       type * t_pred[MAXARGS];
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> f_arg[MAXARGS] </name><overview>"arg1","arg2"..."argMAXARGS"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// Ҹΰɽ"arg1","arg2"..."argMAXARGS"ɽѿˤǤLiLFeSץ"arg1","arg2"..."argMAXARGS"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const feature * f_arg[MAXARGS];
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> f_chead </name><overview>"chead"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// headɽ"chead"ɽѿǤLiLFeSץ"chead"бޤ<BR>
/// 㤨<BR>
/// a(X, Y) :- b(X), !, X = Y.<BR>
/// ȤץबäȤҸ":-""chead"ϡ"a(X,Y)"ˤʤޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const feature * f_chead;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> f_cbody </name><overview>"cbody"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// bodyɽ"cbody"ɽѿǤLiLFeSץ"cbody"бޤ<BR>
/// 㤨<BR>
/// a(X, Y) :- b(X), !, X = Y.<BR>
/// ȤץबäȤҸ":-""cbody"ϡ"b(X), !, X = Y."ˤʤޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const feature * f_cbody;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> f_lilfesfileinfo </name><overview>"lilfesfileinfo"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "lilfesfileinfo"ɽѿǤ
/// </p>
/// </jpn></desc>
/// <body>
extern const feature * f_lilfesfileinfo;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> f_lilfesfilename </name><overview>"lilfesfilename"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "lilfesfilename"ɽѿǤ
/// </p>
/// </jpn></desc>
/// <body>
extern const feature * f_lilfesfilename;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> f_lilfesfileline </name><overview>"lilfesfileline"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "lilfesfileline"ɽѿǤ
/// </p>
/// </jpn></desc>
/// <body>
extern const feature * f_lilfesfileline;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_int </name><overview> "integer"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// lilfes"integer"ɽѿǤƤϤηΥ֥פˤʤޤ
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_int;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_flo </name><overview> "float"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// lilfes"float"ɽѿǤƤưοͤϤηΥ֥פˤʤޤ
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_flo;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_chr </name><overview> "char"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// lilfes"char"ɽѿǤƤʸϤηΥ֥פˤʤޤ<BR>
/// ηϸ߻ȤƤޤ
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_chr;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_stg </name><overview> "string"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// lilfes"string"ɽѿǤƤʸϤηΥ֥פˤʤޤ
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_stg;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_feature </name><overview> ɽ </overview>
/// <desc><jpn>
/// <p>
/// ɽƤη`feature'Υ֥פˤʤäƤޤt_feature`feature'ǼѿǤ
/// </p>
/// </jpn></desc>
/// <body>
extern       type * t_feature;
/// </body></vardef>


// types in fariths.cpp

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_comma </name><overview> ","ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ","ɽѿǤLiLFeSץη","бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_comma;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_semicolon </name><overview> ";"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ";"ɽѿǤLiLFeSץη";"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_semicolon;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_ifthen </name><overview> "->"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "->" ɽѿǤLiLFeSץη"->"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_ifthen;
/// </body></vardef>



/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_plus </name><overview> "+" ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "+" ɽѿǤLiLFeSץη"+"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_plus;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_minus </name><overview> "-" ɽѿ </overview>
/// <desc><jpn>
/// <p>
///  "-" ɽѿǤLiLFeSץη"-"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_minus;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_aster </name><overview> "*" ɽ </overview>
/// <desc><jpn>
/// <p>
/// "*" ɽѿǤLiLFeSץη"*"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_aster;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_slash </name><overview> "/" ɽ </overview>
/// <desc><jpn>
/// <p>
/// "/" ɽѿǤLiLFeSץη"/"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_slash;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_intdiv </name><overview> "//" ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "//" ɽѿǤLiLFeSץη"//"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_intdiv;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_modulo </name><overview> ;黻"mod" ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "mod" ɽѿǤLiLFeSץη"mod"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_modulo;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_cmpl </name><overview> ӱ黻 "<" ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ӱ黻 "<" ɽѿǤLiLFeSץη"<"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_cmpl;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_cmple </name><overview> ӱ黻 "<=" ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ӱ黻 "<="ɽѿǤLiLFeSץη"<="бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_cmple;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_cmpg </name><overview> ӱ黻 ">" ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ӱ黻 ">" ɽѿǤLiLFeSץη">"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_cmpg;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_cmpge </name><overview> ӱ黻 ">=" ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ӱ黻 ">=" ɽѿǤLiLFeSץη">="бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_cmpge;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_cmpeq </name><overview> ӱ黻 "=:=" ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ӱ黻 "=:= "ɽѿǤLiLFeSץη"=:="бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_cmpeq;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_cmpne </name><overview> ӱ黻 "=\=" ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ӱ黻 "=\=" ɽѿǤLiLFeSץη"=\="бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_cmpne;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_circm </name><overview> "^" ɽѿ </overview>
/// <desc><jpn>
/// <p> 
/// "^" ɽѿǤLiLFeSץη"^"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_circm;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_is </name><overview> "is"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// "is"ɽѿǤLiLFeSץη"is"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_is;
/// </body></vardef>



/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_bitand </name><overview> ӥåȱ黻AND黻"/\\"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ӥåȱ黻AND黻"/\\"ɽѿǤLiLFeSץη"/\\"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_bitand;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_bitor </name><overview> ӥåȱ黻OR黻"\/"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ӥåȱ黻OR黻"\/"ɽѿǤLiLFeSץη"\/"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_bitor;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_bitxor </name><overview> ӥåȱ黻XOR黻"#"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ӥåȱ黻XOR黻"#"ɽѿǤLiLFeSץη"#"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_bitxor;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_bitnot </name><overview> ӥåȱ黻NOT黻"\"ɽѿ </overview>
/// <desc><jpn>
/// <p>
/// ӥåȱ黻NOT黻"\"ɽѿǤLiLFeSץη"\"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_bitnot;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> t_macro </name><overview> ":-"ɽ </overview>
/// <desc><jpn>
/// <p>
/// ":-"ɽǤLiLFeSץη":-"бޤ<BR>
/// </p>
/// </jpn></desc>
/// <body>
extern const type * t_macro;
/// </body></vardef>

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

// halt/1 ƤФ줿ꤲ㳰Ǥ
class halt_exception {
private:
  machine* mach;
  int return_code;

public:
  explicit halt_exception( machine* m, int c = 0 ) : mach( m ), return_code( c ) {}
  virtual ~halt_exception() {}

  machine* GetMachine() const { return mach; }
  int GetReturnCode() const { return return_code; }
};

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

namespace builtin {

  // defined in builtin.cpp
  bool dynamic( machine&, FSP );
  bool is_dynamic( machine&, FSP );
  bool multifile( machine&, FSP );
  bool is_multifilx( machine&, FSP );
  bool disp_result( machine&, FSP );
  bool findall( machine&, FSP, FSP, FSP );
  bool findall_4( machine&, FSP, FSP, FSP, FSP );
  bool lilfes_assert( machine&, FSP );
  bool lilfes_asserta( machine&, FSP );
  bool lilfes_version( machine&, FSP );
  bool lilfes_eval( machine&, FSP, FSP );         // lilfes builtin "eval"
  bool lilfes_eval_3( machine&, FSP, FSP, FSP );  // eval_with_varname
  bool lilfes_call( machine&, FSP );              // lilfes builtin "call"

  // defined in builtinfs.cpp
  bool copy( machine&, FSP, FSP );
  bool normalize( machine&, FSP, FSP );
  bool canonical_copy( machine&, FSP, FSP );
  bool unifiable( machine&, FSP, FSP );
  bool isshared( machine&, FSP, FSP );
  bool isnotshared( machine&, FSP, FSP );
  bool b_equiv( machine&, FSP, FSP );
  core_p recopy(core_p, machine&);
  bool recopy( machine&, FSP, FSP );
  bool identical( machine&, FSP, FSP );
  bool not_identical( machine&, FSP, FSP );
  bool compound( machine&, FSP );
  bool simple( machine&, FSP );
  bool follow( machine&, FSP, FSP, FSP );
  bool follow_if_exists( machine&, FSP, FSP, FSP );
  bool restriction( machine&, FSP, FSP );
  bool overwrite( machine&, FSP, FSP, FSP );
  bool subnodelist( machine&, FSP, FSP );
  bool subnodelist_count( machine&, FSP, FSP );
  bool sharednodelist( machine&, FSP, FSP );
  bool contains( machine&, FSP, FSP );
  bool equivalent( machine&, FSP, FSP );
  bool not_equivalent( machine&, FSP, FSP );
  bool subsume( machine&, FSP, FSP );
  bool type_equal( machine&, FSP, FSP );
  bool type_subsume( machine&, FSP, FSP );
  bool type_toptype( machine&, FSP, FSP );
  bool type_copy( machine&, FSP, FSP );
  bool type_unify( machine&, FSP, FSP );
  bool type_common( machine&, FSP, FSP, FSP );
  bool type_nfeature( machine&, FSP, FSP );
  bool type_featurelist( machine&, FSP, FSP );
  bool type_havefeature( machine&, FSP, FSP );
  bool type_subtypes( machine&, FSP, FSP );
  bool type_nsubtypes( machine&, FSP, FSP );
  bool type_supertypes( machine&, FSP, FSP );
  bool type_nsupertypes( machine&, FSP, FSP );
  bool type_unifiables( machine&, FSP, FSP );
  bool type_nunifiables( machine&, FSP, FSP );
  bool type_directsubtypes( machine&, FSP, FSP );
  bool type_directsupertypes( machine&, FSP, FSP );
  bool fs_compare( machine&, FSP, FSP, FSP );

}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

#define LILFES_BUILTIN_PRED_0(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_0(func, name, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_1(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_1(func, name, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_2(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_2(func, name, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_3(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_3(func, name, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_4(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_4(func, name, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_5(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_5(func, name, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_6(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_6(func, name, lilfes::module::BuiltinModule())

#define LILFES_BUILTIN_DIRECTIVE_0(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_0(func, name, lilfes::module::DirectiveModule())
#define LILFES_BUILTIN_DIRECTIVE_1(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_1(func, name, lilfes::module::DirectiveModule())
#define LILFES_BUILTIN_DIRECTIVE_2(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_2(func, name, lilfes::module::DirectiveModule())
#define LILFES_BUILTIN_DIRECTIVE_3(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_3(func, name, lilfes::module::DirectiveModule())
#define LILFES_BUILTIN_DIRECTIVE_4(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_4(func, name, lilfes::module::DirectiveModule())
#define LILFES_BUILTIN_DIRECTIVE_5(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_5(func, name, lilfes::module::DirectiveModule())
#define LILFES_BUILTIN_DIRECTIVE_6(func, name) LILFES_BUILTIN_PRED_WITH_MODULE_6(func, name, lilfes::module::DirectiveModule())

#define LILFES_BUILTIN_PRED_OVERLOAD_0(func, name, parent) LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_0(func, name, parent, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_OVERLOAD_1(func, name, parent) LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_1(func, name, parent, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_OVERLOAD_2(func, name, parent) LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_2(func, name, parent, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_OVERLOAD_3(func, name, parent) LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_3(func, name, parent, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_OVERLOAD_4(func, name, parent) LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_4(func, name, parent, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_OVERLOAD_5(func, name, parent) LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_5(func, name, parent, lilfes::module::BuiltinModule())
#define LILFES_BUILTIN_PRED_OVERLOAD_6(func, name, parent) LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_6(func, name, parent, lilfes::module::BuiltinModule())

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_MODULE_0 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_MODULE_0(func, name, module)					\
	class _bi_##name : public procthunk						\
	{										\
	public:										\
		_bi_##name() : procthunk(0) { }						\
		virtual void execwork(machine &);					\
		static bool execwork_internal(machine &);				\
		static void init();							\
		static const char *className;						\
		virtual const char *ClassName() { return className; }			\
	};										\
											\
	const char *_bi_##name::className = "builtin(" #name ")";				\
											\
	void _bi_##name::init()								\
	{										\
		type *t = new type(#name, (module));						\
		t->SetAsChildOf(t_pred[0]);				t->Fix();	\
		dummyturbo(new proc_builtin(t, 0, new _bi_##name()));			\
	}										\
											\
	static InitFunction INIT_##name(_bi_##name::init,100);				\
											\
	void _bi_##name::execwork(machine &mach)						\
          {										\
            NGETARGS0(mach)								\
            if( execwork_internal(mach) ){  return ; }					\
            else{ mach.Fail();return ; }						\
	}										\
	bool _bi_##name::execwork_internal(machine &mach)                         \
        { \
          return func(mach); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_MODULE_1 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_MODULE_1(func, name, module)					\
	class _bi_##name : public procthunk						\
	{										\
	public:										\
		_bi_##name() : procthunk(1) { }						\
		virtual void execwork(machine &);					\
		static bool execwork_internal(machine & , FSP);			\
		static void init();							\
		static const char *className;						\
		virtual const char *ClassName() { return className; }			\
	};										\
											\
	const char *_bi_##name::className = "builtin(" #name ")";				\
											\
	void _bi_##name::init()								\
	{										\
		type *t = new type(#name, (module));						\
		t->SetAsChildOf(t_pred[1]);				t->Fix();	\
		dummyturbo(new proc_builtin(t, 1, new _bi_##name()));			\
	}										\
											\
	static InitFunction INIT_##name(_bi_##name::init,100);				\
											\
	void _bi_##name::execwork(machine &mach)						\
          {										\
            NGETARGS1(mach,arg1)							\
            if( execwork_internal(mach,arg1) ){  return ; }				\
            else{ mach.Fail();return ; }						\
	}										\
	bool _bi_##name::execwork_internal(machine &mach , FSP arg1) \
        { \
          return func(mach, arg1); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_MODULE_2 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_MODULE_2(func, name, module)					\
	class _bi_##name : public procthunk						\
	{										\
	public:										\
		_bi_##name() : procthunk(2) { }						\
		virtual void execwork(machine &);					\
		static bool execwork_internal(machine & , FSP ,FSP);			\
		static void init();							\
		static const char *className;						\
		virtual const char *ClassName() { return className; }			\
	};										\
											\
	const char *_bi_##name::className = "builtin(" #name ")";				\
											\
	void _bi_##name::init()								\
	{										\
		type *t = new type(#name, (module));						\
		t->SetAsChildOf(t_pred[2]);				t->Fix();	\
		dummyturbo(new proc_builtin(t, 2, new _bi_##name()));			\
	}										\
											\
	static InitFunction INIT_##name(_bi_##name::init,100);				\
											\
	void _bi_##name::execwork(machine &mach)						\
          {										\
            NGETARGS2(mach,arg1,arg2)							\
            if( execwork_internal(mach,arg1,arg2) ){  return ; }			\
            else{ mach.Fail();return ; }						\
	}										\
	bool _bi_##name::execwork_internal(machine &mach , FSP arg1 , FSP arg2) \
        { \
          return func(mach, arg1, arg2); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_MODULE_3 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_MODULE_3(func, name, module)					\
	class _bi_##name : public procthunk						\
	{										\
	public:										\
		_bi_##name() : procthunk(3) { }						\
		virtual void execwork(machine &);					\
		static bool execwork_internal(machine & , FSP , FSP , FSP);		\
		static void init();							\
		static const char *className;						\
		virtual const char *ClassName() { return className; }			\
	};										\
											\
	const char *_bi_##name::className = "builtin(" #name ")";				\
											\
	void _bi_##name::init()								\
	{										\
		type *t = new type(#name, (module));						\
		t->SetAsChildOf(t_pred[3]);				t->Fix();	\
		dummyturbo(new proc_builtin(t, 3, new _bi_##name()));			\
	}										\
											\
	static InitFunction INIT_##name(_bi_##name::init,100);				\
											\
	void _bi_##name::execwork(machine &mach)						\
          {										\
            NGETARGS3(mach,arg1,arg2,arg3)							\
            if( execwork_internal(mach,arg1,arg2,arg3) ){  return ; }			\
            else{ mach.Fail();return ; }						\
	}										\
	bool _bi_##name::execwork_internal(machine &mach , FSP arg1 , FSP arg2 , FSP arg3) \
        { \
          return func(mach, arg1, arg2, arg3); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_MODULE_4 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_MODULE_4(func, name, module)					\
	class _bi_##name : public procthunk						\
	{										\
	public:										\
		_bi_##name() : procthunk(4) { }						\
		virtual void execwork(machine &);					\
		static bool execwork_internal(machine & , FSP , FSP , FSP , FSP);	\
		static void init();							\
		static const char *className;						\
		virtual const char *ClassName() { return className; }			\
	};										\
											\
	const char *_bi_##name::className = "builtin(" #name ")";				\
											\
	void _bi_##name::init()								\
	{										\
		type *t = new type(#name, (module));						\
		t->SetAsChildOf(t_pred[4]);				t->Fix();	\
		dummyturbo(new proc_builtin(t, 4, new _bi_##name()));			\
	}										\
											\
	static InitFunction INIT_##name(_bi_##name::init,100);				\
											\
	void _bi_##name::execwork(machine &mach)						\
          {										\
            NGETARGS4(mach,arg1,arg2,arg3,arg4)							\
            if( execwork_internal(mach,arg1,arg2,arg3,arg4) ){  return ; }			\
            else{ mach.Fail();return ; }						\
	}										\
	bool _bi_##name::execwork_internal(machine &mach , FSP arg1 , FSP arg2 , FSP arg3 , FSP arg4) \
        { \
          return func(mach, arg1, arg2, arg3, arg4); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_MODULE_5 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_MODULE_5(func, name, module)					\
	class _bi_##name : public procthunk						\
	{										\
	public:										\
		_bi_##name() : procthunk(5) { }						\
		virtual void execwork(machine &);					\
		static bool execwork_internal(machine & , FSP , FSP , FSP , FSP , FSP);	\
		static void init();							\
		static const char *className;						\
		virtual const char *ClassName() { return className; }			\
	};										\
											\
	const char *_bi_##name::className = "builtin(" #name ")";				\
											\
	void _bi_##name::init()								\
	{										\
		type *t = new type(#name, (module));						\
		t->SetAsChildOf(t_pred[5]);				t->Fix();	\
		dummyturbo(new proc_builtin(t, 5, new _bi_##name()));			\
	}										\
											\
	static InitFunction INIT_##name(_bi_##name::init,100);				\
											\
	void _bi_##name::execwork(machine &mach)						\
          {										\
            NGETARGS5(mach,arg1,arg2,arg3,arg4,arg5)							\
            if( execwork_internal(mach,arg1,arg2,arg3,arg4,arg5) ){  return ; }			\
            else{ mach.Fail();return ; }						\
	}										\
	bool _bi_##name::execwork_internal(machine &mach , FSP arg1 , FSP arg2 , FSP arg3 , FSP arg4 , FSP arg5) \
        { \
          return func(mach, arg1, arg2, arg3, arg4, arg5); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_MODULE_6 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_MODULE_6(func, name, module)					\
	class _bi_##name : public procthunk						\
	{										\
	public:										\
		_bi_##name() : procthunk(6) { }						\
		virtual void execwork(machine &);					\
		static bool execwork_internal(machine & , FSP , FSP , FSP , FSP , FSP , FSP);	\
		static void init();							\
		static const char *className;						\
		virtual const char *ClassName() { return className; }			\
	};										\
											\
	const char *_bi_##name::className = "builtin(" #name ")";				\
											\
	void _bi_##name::init()								\
	{										\
		type *t = new type(#name, (module));						\
		t->SetAsChildOf(t_pred[6]);				t->Fix();	\
		dummyturbo(new proc_builtin(t, 6, new _bi_##name()));			\
	}										\
											\
	static InitFunction INIT_##name(_bi_##name::init,100);				\
											\
	void _bi_##name::execwork(machine &mach)						\
          {										\
            NGETARGS6(mach,arg1,arg2,arg3,arg4,arg5,arg6)							\
            if( execwork_internal(mach,arg1,arg2,arg3,arg4,arg5,arg6) ){  return ; }			\
            else{ mach.Fail();return ; }						\
	}										\
	bool _bi_##name::execwork_internal(machine &mach , FSP arg1 , FSP arg2 , FSP arg3 , FSP arg4 , FSP arg5 , FSP arg6) \
        { \
          return func(mach, arg1, arg2, arg3, arg4, arg5, arg6); \
        }
/// </body></macrodef>

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_OVERLOAD_0 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_0(func, name, parent, module)						\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(0) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &);						\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" #name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(#name, module);				\
		t->SetAsChildOf(t_pred[0]);							\
		t->SetAsChildOf(module->Search(#parent));			\
		t->Fix();									\
		dummyturbo(new proc_builtin(t, 0, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100+0);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS0(mach)									\
          if( execwork_internal(mach) ){ return ; }				\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach) { \
          return func( mach ); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_1 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_1(func, name, parent, module)						\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(1) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &, FSP);			\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" #name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(#name, module);				\
		t->SetAsChildOf(t_pred[1]);							\
		t->SetAsChildOf(module->Search(#parent));			\
		t->Fix();									\
		dummyturbo(new proc_builtin(t, 1, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100+1);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS1(mach,arg1)									\
          if( execwork_internal(mach, arg1) ){ return ; }				\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach, FSP arg1) { \
          return func( mach, arg1 ); \
        }
/// </body></macrodef>
          
/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_2 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_2(func, name, parent, module)						\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(2) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &, FSP, FSP);			\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" #name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(#name, module);				\
		t->SetAsChildOf(t_pred[2]);							\
		t->SetAsChildOf(module->Search(#parent));			\
		t->Fix();									\
		dummyturbo(new proc_builtin(t, 2, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100+2);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS2(mach,arg1,arg2)									\
          if( execwork_internal(mach, arg1, arg2) ){ return ; }				\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach, FSP arg1, FSP arg2) { \
          return func( mach, arg1, arg2 ); \
        }
/// </body></macrodef>
          
/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_3 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_3(func, name, parent, module)						\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(3) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &, FSP, FSP, FSP);			\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" #name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(#name, module);				\
		t->SetAsChildOf(t_pred[3]);							\
		t->SetAsChildOf(module->Search(#parent));			\
		t->Fix();									\
		dummyturbo(new proc_builtin(t, 3, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100+3);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS3(mach,arg1,arg2,arg3)									\
          if( execwork_internal(mach, arg1, arg2, arg3) ){ return ; }				\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach, FSP arg1, FSP arg2, FSP arg3) { \
          return func( mach, arg1, arg2, arg3 ); \
        }
/// </body></macrodef>
          
/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_4 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_4(func, name, parent, module)						\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(4) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &, FSP, FSP, FSP, FSP);			\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" #name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(#name, module);				\
		t->SetAsChildOf(t_pred[4]);							\
		t->SetAsChildOf(module->Search(#parent));			\
		t->Fix();									\
		dummyturbo(new proc_builtin(t, 4, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100+4);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS4(mach,arg1,arg2,arg3,arg4)									\
          if( execwork_internal(mach, arg1, arg2, arg3, arg4) ){ return ; }				\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach, FSP arg1, FSP arg2, FSP arg3, FSP arg4) { \
          return func( mach, arg1, arg2, arg3, arg4 ); \
        }
/// </body></macrodef>
          
/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_5 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_5(func, name, parent, module)						\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(5) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &, FSP, FSP, FSP, FSP, FSP);			\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" #name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(#name, module);				\
		t->SetAsChildOf(t_pred[5]);							\
		t->SetAsChildOf(module->Search(#parent));			\
		t->Fix();									\
		dummyturbo(new proc_builtin(t, 5, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100+5);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS5(mach,arg1,arg2,arg3,arg4,arg5)									\
          if( execwork_internal(mach, arg1, arg2, arg3, arg4, arg5) ){ return ; }				\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach, FSP arg1, FSP arg2, FSP arg3, FSP arg4, FSP arg5) { \
          return func( mach, arg1, arg2, arg3, arg4, arg5 ); \
        }
/// </body></macrodef>
          
/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_6 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_OVERLOAD_WITH_MODULE_6(func, name, parent, module)						\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(6) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &, FSP, FSP, FSP, FSP, FSP, FSP);			\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" #name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(#name, module);				\
		t->SetAsChildOf(t_pred[6]);							\
		t->SetAsChildOf(module->Search(#parent));			\
		t->Fix();									\
		dummyturbo(new proc_builtin(t, 6, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100+6);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS6(mach,arg1,arg2,arg3,arg4,arg5,arg6)									\
          if( execwork_internal(mach, arg1, arg2, arg3, arg4, arg5, arg6) ){ return ; }				\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach, FSP arg1, FSP arg2, FSP arg3, FSP arg4, FSP arg5, FSP arg6) { \
          return func( mach, arg1, arg2, arg3, arg4, arg5, arg6 ); \
        }
/// </body></macrodef>

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_NAME_0</name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_NAME_0(func, name, lilfes_name)				\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(0) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &);					\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" lilfes_name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(lilfes_name, lilfes::module::CoreModule()); t->SetAsChildOf(pred);	t->Fix();	\
		type *s = new type(lilfes_name "/" "0", lilfes::module::CoreModule()); s->SetAsChildOf(t); 		\
				s->SetAsChildOf(t_pred[0]);				s->Fix();	\
		dummyturbo(new proc_builtin(s, 0, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS0(mach)									\
          if( execwork_internal(mach) ){ return ; }						\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach) { \
          return func( mach ); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_NAME_1</name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_NAME_1(func, name, lilfes_name)				\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(1) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &,FSP);					\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" lilfes_name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(lilfes_name, lilfes::module::CoreModule()); t->SetAsChildOf(pred);	t->Fix();	\
		type *s = new type(lilfes_name "/" "1", lilfes::module::CoreModule()); s->SetAsChildOf(t); 		\
				s->SetAsChildOf(t_pred[1]);				s->Fix();	\
		dummyturbo(new proc_builtin(s, 1, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS1(mach,arg1)									\
          if( execwork_internal(mach,arg1) ){ return ; }					\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach,FSP arg1) { \
          return func( mach, arg1 ); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_NAME_2</name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_NAME_2(func, name, lilfes_name)				\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(2) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &,FSP,FSP);				\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" lilfes_name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(lilfes_name, lilfes::module::CoreModule()); t->SetAsChildOf(pred);	t->Fix();	\
		type *s = new type(lilfes_name "/" "2", lilfes::module::CoreModule()); s->SetAsChildOf(t); 		\
				s->SetAsChildOf(t_pred[2]);				s->Fix();	\
		dummyturbo(new proc_builtin(s, 2, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS2(mach,arg1,arg2)								\
          if( execwork_internal(mach,arg1,arg2) ){ return ; }					\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach,FSP arg1,FSP arg2) { \
          return func( mach, arg1, arg2 ); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_NAME_3</name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_NAME_3(func, name, lilfes_name)				\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(3) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &,FSP,FSP,FSP);				\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" lilfes_name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(lilfes_name, lilfes::module::CoreModule()); t->SetAsChildOf(pred);	t->Fix();	\
		type *s = new type(lilfes_name "/" "3", lilfes::module::CoreModule()); s->SetAsChildOf(t); 		\
				s->SetAsChildOf(t_pred[3]);				s->Fix();	\
		dummyturbo(new proc_builtin(s, 3, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS3(mach,arg1,arg2,arg3)								\
          if( execwork_internal(mach,arg1,arg2,arg3) ){ return ; }					\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach,FSP arg1,FSP arg2,FSP arg3) { \
          return func( mach, arg1, arg2, arg3 ); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_NAME_4</name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_NAME_4(func, name, lilfes_name)				\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(4) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &,FSP,FSP,FSP);				\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" lilfes_name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(lilfes_name, lilfes::module::CoreModule()); t->SetAsChildOf(pred);	t->Fix();	\
		type *s = new type(lilfes_name "/" "4", lilfes::module::CoreModule()); s->SetAsChildOf(t); 		\
				s->SetAsChildOf(t_pred[4]);				s->Fix();	\
		dummyturbo(new proc_builtin(s, 4, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS4(mach,arg1,arg2,arg3,arg4)								\
          if( execwork_internal(mach,arg1,arg2,arg3,arg4) ){ return ; }					\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach,FSP arg1,FSP arg2,FSP arg3,FSP arg4) { \
          return func( mach, arg1, arg2, arg3, arg4 ); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_NAME_5</name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_NAME_5(func, name, lilfes_name)				\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(5) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &,FSP,FSP,FSP,FSP,FSP);			\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" lilfes_name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(lilfes_name, lilfes::module::CoreModule()); t->SetAsChildOf(pred);	t->Fix();	\
		type *s = new type(lilfes_name "/" "5", lilfes::module::CoreModule()); s->SetAsChildOf(t); 		\
				s->SetAsChildOf(t_pred[5]);				s->Fix();	\
		dummyturbo(new proc_builtin(s, 5, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS5(mach,arg1,arg2,arg3,arg4,arg5)								\
          if( execwork_internal(mach,arg1,arg2,arg3,arg4,arg5) ){ return ; }					\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach,FSP arg1,FSP arg2,FSP arg3,FSP arg4,FSP arg5) { \
          return func( mach, arg1, arg2, arg3, arg4, arg5 ); \
        }
/// </body></macrodef>

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_PRED_WITH_NAME_6</name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_PRED_WITH_NAME_6(func, name, lilfes_name)				\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(6) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &,FSP,FSP,FSP,FSP,FSP,FSP);		\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" lilfes_name ")";				\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(lilfes_name, lilfes::module::CoreModule()); t->SetAsChildOf(pred);	t->Fix();	\
		type *s = new type(lilfes_name "/" "6", lilfes::module::CoreModule()); s->SetAsChildOf(t); 		\
				s->SetAsChildOf(t_pred[6]);				s->Fix();	\
		dummyturbo(new proc_builtin(s, 6, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS6(mach,arg1,arg2,arg3,arg4,arg5,arg6)								\
          if( execwork_internal(mach,arg1,arg2,arg3,arg4,arg5,arg6) ){ return ; }					\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach,FSP arg1,FSP arg2,FSP arg3,FSP arg4,FSP arg5,FSP arg6) { \
          return func( mach, arg1, arg2, arg3, arg4, arg5, arg6 ); \
        }
/// </body></macrodef>

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_ARITH_2 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_ARITH_2(func,name,lilfes_name)				\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(2) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &,FSP,FSP);				\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" lilfes_name ")";					\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(lilfes_name, lilfes::module::CoreModule()); t->SetAsChildOf(pred);	t->Fix();	\
		type *s = new type(lilfes_name "/" "1", lilfes::module::CoreModule()); s->SetAsChildOf(t);		\
				s->SetAsChildOf(t_pred[1]);			s->Fix();	\
		type *r = new type(lilfes_name "/" "2", lilfes::module::CoreModule()); r->SetAsChildOf(s); 	\
				r->SetAsChildOf(t_pred[2]);				r->Fix();	\
		dummyturbo(new proc_builtin(r, 2, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS2(mach,arg1,arg2)								\
          if( execwork_internal(mach,arg1,arg2) ){ return ; }					\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach,FSP arg1,FSP arg2) { \
          return func( mach, arg1, arg2 ); \
        }
/// </body></macrodef>
          
/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_ARITH_3 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_ARITH_3(func,name,lilfes_name)						\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(3) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &,FSP,FSP,FSP);				\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" lilfes_name ")";					\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(lilfes_name, lilfes::module::CoreModule()); t->SetAsChildOf(pred);	t->Fix();	\
		type *s = new type(lilfes_name "/" "2", lilfes::module::CoreModule()); s->SetAsChildOf(t);		\
				s->SetAsChildOf(t_pred[2]);			s->Fix();	\
		type *r = new type(lilfes_name "/" "3", lilfes::module::CoreModule()); r->SetAsChildOf(s); 	\
				r->SetAsChildOf(t_pred[3]);				r->Fix();	\
		dummyturbo(new proc_builtin(r, 3, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS3(mach,arg1,arg2,arg3)							\
          if( execwork_internal(mach,arg1,arg2,arg3) ){ return ; }				\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach,FSP arg1,FSP arg2,FSP arg3) { \
          return func( mach, arg1, arg2, arg3 ); \
        }
/// </body></macrodef>
////////BUILTIN_ARITH_2,3///////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////
/// <macrodef>
/// <name> LILFES_BUILTIN_ARITH_UNARY_3 </name>
/// <desc>
/// </desc>
/// <body>
#define LILFES_BUILTIN_ARITH_UNARY_3(func, name, lilfes_name)				 	\
	class _bi_##name : public procthunk							\
	{											\
	public:											\
		_bi_##name() : procthunk(3) { }							\
		virtual void execwork(machine &);						\
		static bool execwork_internal(machine &,FSP,FSP,FSP);				\
		static void init();								\
		static const char *className;							\
		virtual const char *ClassName() { return className; }				\
	};											\
												\
	const char *_bi_##name::className = "builtin(" lilfes_name ")";					\
												\
	void _bi_##name::init()									\
	{											\
		type *t = new type(lilfes_name, lilfes::module::CoreModule()); t->SetAsChildOf(pred);	t->Fix();	\
		type *q = new type(lilfes_name "/" "1", lilfes::module::CoreModule()); q->SetAsChildOf(t); 		\
				q->SetAsChildOf(t_pred[1]);			q->Fix();	\
		type *s = new type(lilfes_name "/" "2", lilfes::module::CoreModule()); s->SetAsChildOf(q); 	\
				s->SetAsChildOf(t_pred[2]);			s->Fix();	\
		type *r = new type(lilfes_name "/" "3", lilfes::module::CoreModule()); r->SetAsChildOf(s); 	\
				r->SetAsChildOf(t_pred[3]);				r->Fix();	\
		dummyturbo(new proc_builtin(r, 3, new _bi_##name()));				\
	}											\
												\
	static InitFunction INIT_##name(_bi_##name::init,100);					\
												\
	void _bi_##name::execwork(machine &mach)							\
        {											\
          NGETARGS3(mach,arg1,arg2,arg3)							\
          if( execwork_internal(mach,arg1,arg2,arg3) ){ return ; }				\
          else{  mach.Fail();return ; }								\
	}											\
	bool _bi_##name::execwork_internal(machine &mach,FSP arg1,FSP arg2,FSP arg3) { \
          return func( mach, arg1, arg2, arg3 ); \
        }
/// </body></macrodef>

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

#define NGETARGS0(mach)  P2(className);

#ifdef DOASSERT

#define NGETARGS1(mach,arg1)	NGETARGS0(mach);								\
		mach.SetRP(1); FSP arg1(mach, c2PTR(mach.ReadLocal(0)));

#define NGETARGS2(mach,arg1,arg2)	NGETARGS1(mach,arg1);							\
		mach.SetRP(2); FSP arg2(mach, c2PTR(mach.ReadLocal(1)));

#define NGETARGS3(mach,arg1,arg2,arg3)	NGETARGS2(mach,arg1,arg2);						\
		mach.SetRP(3); FSP arg3(mach, c2PTR(mach.ReadLocal(2)));

#define NGETARGS4(mach,arg1,arg2,arg3,arg4)	NGETARGS3(mach,arg1,arg2,arg3);					\
		mach.SetRP(4); FSP arg4(mach, c2PTR(mach.ReadLocal(3)));

#define NGETARGS5(mach,arg1,arg2,arg3,arg4,arg5)	NGETARGS4(mach,arg1,arg2,arg3,arg4);			\
		mach.SetRP(5); FSP arg5(mach, c2PTR(mach.ReadLocal(4)));

#define NGETARGS6(mach,arg1,arg2,arg3,arg4,arg5,arg6)	NGETARGS5(mach,arg1,arg2,arg3,arg4,arg5);		\
		mach.SetRP(6); FSP arg6(mach, c2PTR(mach.ReadLocal(5)));

#define NGETARGS7(mach,arg1,arg2,arg3,arg4,arg5,arg6,arg7)	NGETARGS6(mach,arg1,arg2,arg3,arg4,arg5,arg6);	\
		mach.SetRP(7); FSP arg7(mach, c2PTR(mach.ReadLocal(6)));

#else
#define NGETARGS1(mach , arg1)	NGETARGS0(mach);								\
		 FSP arg1(mach, c2PTR(mach.ReadLocal(0)));

#define NGETARGS2(mach,arg1,arg2)	NGETARGS1(mach,arg1);							\
		 FSP arg2(mach, c2PTR(mach.ReadLocal(1)));

#define NGETARGS3(mach,arg1,arg2,arg3)	NGETARGS2(mach,arg1,arg2);						\
		 FSP arg3(mach, c2PTR(mach.ReadLocal(2)));

#define NGETARGS4(mach,arg1,arg2,arg3,arg4)	NGETARGS3(mach,arg1,arg2,arg3);					\
		 FSP arg4(mach, c2PTR(mach.ReadLocal(3)));

#define NGETARGS5(mach,arg1,arg2,arg3,arg4,arg5)	NGETARGS4(mach,arg1,arg2,arg3,arg4);			\
		 FSP arg5(mach, c2PTR(mach.ReadLocal(4)));

#define NGETARGS6(mach,arg1,arg2,arg3,arg4,arg5,arg6)	NGETARGS5(mach,arg1,arg2,arg3,arg4,arg5);		\
		 FSP arg6(mach, c2PTR(mach.ReadLocal(5)));

#define NGETARGS7(mach,arg1,arg2,arg3,arg4,arg5,arg6,arg7)	NGETARGS6(mach,arg1,arg2,arg3,arg4,arg5,arg6);	\
		 FSP arg7(mach, c2PTR(mach.ReadLocal(6)));
#endif
/////////////////////////////////////////////////////////////////////////////////////////////////////
// TODO: make lilfes_str_flag

} // namespace lilfes

#endif // __builtin_h
