/* $Id: cell.h,v 1.3 2004/02/08 15:08:40 mak Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */

///  <ID>$Id: cell.h,v 1.3 2004/02/08 15:08:40 mak Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>cell.h</name>
//
///  <overview>
///  <jpn>cell 롼</jpn>
///  <eng> cell operation routine </eng>
///  </overview>

/// <notiondef>
/// <name> cell_overview </name>
/// <title> cell 롼 </title>
/// 
/// <desc>
/// 
/// <p> <ref>cell.h</ref>¤˳ǼȤ˥ȥǡФˤꡢ꤫ФȤ˥ȥǡڤΥꤹΤ˻Ȥޤ<br>
/// </p>
/// </desc>
/// <see> </see>
/// </notiondef>

//
//  LightSpeed HPSG Parser Project
//
//  cell.h - Definition of Base classes.
//
//  **LICENSE**
//
//  Change Log:
//
//  96/11/22  Created. / mak
//  97/05/26  Readability improved. / mak

#ifndef __cell_h
#define __cell_h

#include <string.h>

#include "lconfig.h"
#include "basic.h"
#include "hash.h"
#include "lstring.h"
#include "ftype.h"
#include "profile.h"

namespace lilfes {

// String Symbol Class

/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> strsymbol </name>

/// <overview> String Symbol饹</overview>
/// <desc>
/// <p>
///  LiLFeS μǤϡʸ󥷥ܥΤ줾˥ˡʥꥢֹƤƤޤꥢֹʸμΤδط򵭲륯饹 strsymbol 饹Ǥ
/// </p>
/// </desc>
/// <remark>HashTable,VarArrayѤƤޤ</remark>
/// <see></see>
/// <body>
class strsymbol
{
	lstring name;
	int serialno;
	mutable bool used;
	mutable bool permanent;

	static VarArray<const strsymbol *> serialtable;
	static HashTable<strsymbol> hash;

public:
	strsymbol(machine *mach, const char *name);
	~strsymbol();
		
	const char *GetKey() const { return name; } // for hashtable...
  /// HashTableѤΥ᥽åɤǤȤname֤ޤ
	/*const*/ char *GetString() const { return name; }
  /// ʸμΤޤ
	int GetSerialNo() const { return serialno; }
  /// ʸΥꥢֹޤ
	void SetPermanent() const { permanent = true; }
  /// Permanentե饰򥻥åȤޤʸgcǲʤʤޤ
	void SetUsed() const { used = true; }
  /// Usedե饰򥻥åȤޤʸ󤬸߻Ǥ뤳Ȥ򼨤ޤ
	static const strsymbol* Serial(int serial) { return serialtable[serial]; }
  /// ꥢֹ椫б strsymbol 饹Υݥ󥿤ޤ
	static strsymbol* New(machine *mach, const char *n);
  /// ꤵ줿ʸФơǤб strsymbol 饹ФΥݥ󥿤򡢤ʤп strsymbol 饹ݤ֤ޤ
	static int GetSerialCount() { return serialtable.GetSize(); }
  /// ߡꥢֹ椬Ĥޤǳ꿶Ƥ뤫Ĵ٤ޤ
	static void gc(machine *mach);
  /// ʸΥ٥쥯ʻѤƤʤˤ¹Ԥޤ
};
/// </body></classdef>


inline strsymbol* strsymbol::New(machine *mach, const char *n) 
		{ strsymbol *r = hash.Find(n); return r ? r : new strsymbol(mach, n); }


// Definition of cell

// cell is a data type that has a 32-bit width.
// We don't use a class because the performance of function calling loses, so
// We use enum type for cell.
// ____1 and ____2 guarantee that the type has a 32-bit (or 64-bit) width.

#ifdef CELL_64BIT
/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> cell </name>

/// <overview> ͤȤߤˤʤä饹</overview>
/// <desc>
/// <p>
/// ...Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
enum cell { ____1 = -1000000000000L, ____2 = 1000000000000L };
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> cell_int </name>

/// <overview> cell int饹</overview>
/// <desc>
/// <p>
/// cellƱintǤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef uint64 cell_int;
/// </body></classdef>

//////////////////////////////////////////////////////////////////////////
/// <constdef>
/// <name> TAG_SHIFT </name>
/// <overview>ǡʬΥӥåȿɽ</overview>
/// <desc>
/// <jpn>
/// <p>
/// ǡʬΥӥåȿɽǤΤTAG_SHIFTӥåʬ˥եȤХʬĤޤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
const int TAG_SHIFT = 60;
/// </body></constdef>

#else
enum cell { ____1 = -1000000000    , ____2 = 1000000000     };
typedef uint32 cell_int;
const int TAG_SHIFT = 28;
#endif

// machine int / machine char / machine float definition

#ifdef CELL_64BIT
/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> mchar </name>

/// <overview> machine char 饹 </overview>
/// <desc>
/// <p>
/// <ref>cell</ref>˳ǼǤ륵charǤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef uint16 mchar;
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> mint </name>

/// <overview> machine int 饹 </overview>
/// <desc>
/// <p>
/// <ref>cell</ref>˳ǼǤ륵intǤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef int64  mint;
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> mfloat </name>

/// <overview> machine float 饹 </overview>
/// <desc>
/// <p>
/// <ref>cell</ref>˳ǼǤ륵floatǤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef double mfloat;
/// </body></classdef>
#else
typedef uint16 mchar;
typedef int32  mint;
typedef float  mfloat;
#endif

// cell <-> cell_int conversion functions
/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> cell2int </name>
/// <overview>cellcell_intѴޤ</overview>
/// <desc>
/// <p>
/// 
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> cell_int֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline cell_int cell2int(cell c) { return (cell_int)c; }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> int2cell </name>
/// <overview>cell_intcellѴޤ</overview>
/// <desc>
/// <p>
/// 
/// </p>
/// </desc>
/// <args> cell_int֥ȤϤޤ</args>
/// <retval> cell_֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline cell int2cell(cell_int i) { return (cell)i; }
/// </body></funcdef>



// definition of core_p
/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> core_p </name>

/// <overview> ݵΥؤΥݥ󥿥饹</overview>
/// <desc>
/// <p>
/// core (LiLFeS ݵΥ) ؤΥݥ󥿤륯饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef cell_int core_p;
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> int2core_p </name>
/// <overview>cell_intcore_pѴޤ</overview>
/// <desc>
/// <p>
/// <ref>core_p2int</ref>ѴΤ򸵤ᤷޤ
/// </p>
/// </desc>
/// <args> cell_int֥ȤϤޤ</args>
/// <retval> core_p֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline core_p   int2core_p(cell_int i) { return i; }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> core_p2int </name>
/// <overview>core_pcell_intѴޤ</overview>
/// <desc>
/// <p>
/// core_pintΤ褦˰δؿǤ
/// </p>
/// </desc>
/// <args> core_p֥ȤϤޤ</args>
/// <retval> cell_int֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>int2core_p</see>
/// <body>
inline cell_int core_p2int(core_p   i) { return i; }
/// </body></funcdef>


//////////////////////////////////////////////////////////////////////////
/// <constdef>
/// <name> CORE_P_INVALID </name>
/// <overview>̵core_pɽ</overview>
/// <desc>
/// <jpn>
/// <p>
/// ̵core_pɽǤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
const core_p CORE_P_INVALID = ((cell_int)1 << (TAG_SHIFT+2)) - 1;
/// </body></constdef>


// abbreviated form of converting function
#define cp2int core_p2int
#define int2cp int2core_p


/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> cp_plus </name>
/// <overview>Ĥcore_p֥Ȥ¤ޤ</overview>
/// <desc>
/// <p>
/// core_p֥<var>a</var>,<var>b</var>­碌Τ֤ޤ
/// </p>
/// </desc>
/// <args> core_p֥ȤϤޤ</args>
/// <retval> core_p֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline core_p cp_plus(core_p a, core_p b) 
{ 
	return int2core_p(core_p2int(a)+core_p2int(b));
}
/// </body></funcdef>


/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> cp_minus </name>
/// <overview>Ĥcore_p֥Ȥκޤ</overview>
/// <desc>
/// <p>
/// core_p֥<var>a</var><var>b</var>Τ֤ޤ
/// </p>
/// </desc>
/// <args> core_p֥ȤϤޤ</args>
/// <retval> core_p֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline core_p cp_minus(core_p a, core_p b) 
{ 
	return int2core_p(core_p2int(a)-core_p2int(b));
}
/// </body></funcdef>

//////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> tag_t </name>
/// <overview></overview>
/// <desc>
/// <jpn>
/// <p>
/// ɽ󷿤Ǥ<br>
/// ͤб<br>
/// T_PTR =0, T_PTR1=1, T_PTR2=2, T_PTR3=3,<br>
/// T_STR =4, T_FSTR=5, T_VAR =6, T_FVAR=7,<br>
/// T_INT =8, T_FLO =9, T_CHR=10, T_STG =11<br>
/// <br>PTR:ݥ <br>VAR:ѿ <br>F:freeze <br>INT: <br>FLO:¿ <br>STG:ʸ<br>
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
enum tag_t { 
  T_PTR =0,/// ݥ
  T_PTR1=1,
  T_PTR2=2,
  T_PTR3=3,
  T_STR =4,/// structure
  T_FSTR=5,/// freeze structure
  T_VAR =6,/// ѿ
  T_FVAR=7,/// freeze ѿ
  T_INT =8,/// 
  T_FLO =9,/// ¿
  T_CHR=10,/// ʸ
  T_STG =11/// ʸ
};
/// </body></classdef>

//////////////////////////////////////////////////////////////////////////
/// <constdef>
/// <name> TAG_WIDTH </name>
/// <overview>Υӥåȿ</overview>
/// <desc>
/// <jpn>
/// <p>
/// ΥӥåȿʲӥåȻȤäƤ뤫ˤɽǤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
const int TAG_WIDTH = 4;
/// </body></constdef>

//////////////////////////////////////////////////////////////////////////
/// <constdef>
/// <name> TAG_MASK </name>
/// <overview>...</overview>
/// <desc>
/// <jpn>
/// <p>
/// ...ɽǤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
const int TAG_MASK = - ( 1L << TAG_SHIFT );
/// </body></constdef>

//////////////////////////////////////////////////////////////////////////
/// <constdef>
/// <name> NTAG_MASK </name>
/// <overview>TAG_MASKȿžΡ</overview>
/// <desc>
/// <jpn>
/// <p>
/// TAG_MASKȿžΤǤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
const int NTAG_MASK = ~ TAG_MASK ;
/// </body></constdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> Tag </name>
/// <overview>cellΥޤ</overview>
/// <desc>
/// <p>
/// <ref>cell</ref>Υޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> tag_t ֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>tag_t</see>
/// <body>
inline tag_t Tag(cell c) { return (tag_t)(cell2int(c)>>TAG_SHIFT); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> IsPTR </name>
/// <overview>ΥPTRɤĴ٤ޤ</overview>
/// <desc>
/// <p>
/// ΥPTRɤĴ٤ޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> PTRʤtrue򡢤Ǥʤfalse֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline bool IsPTR(cell c)       { return ((cell2int(c) & ((cell_int)0xc << TAG_SHIFT)) == ((cell_int)0x0 << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> IsSTR </name>
/// <overview>ΥSTRɤĴ٤ޤ</overview>
/// <desc>
/// <p>
/// ΥSTRɤĴ٤ޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> STRʤtrue򡢤Ǥʤfalse֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline bool IsSTR(cell c)       { return ((cell2int(c) & ((cell_int)0xe << TAG_SHIFT)) == ((cell_int)0x4 << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> IsVAR </name>
/// <overview>ΥVARɤĴ٤ޤ</overview>
/// <desc>
/// <p>
/// ΥVARɤĴ٤ޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> VARʤtrue򡢤Ǥʤfalse֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline bool IsVAR(cell c)       { return ((cell2int(c) & ((cell_int)0xe << TAG_SHIFT)) == ((cell_int)0x6 << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> IsSTRorVAR </name>
/// <overview>ΥSTR⤷VARɤĴ٤ޤ</overview>
/// <desc>
/// <p>
/// ΥSTR⤷VARɤĴ٤ޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> STR⤷VARʤtrue򡢤Ǥʤfalse֤ޤ  </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline bool IsSTRorVAR(cell c)  { return ((cell2int(c) & ((cell_int)0xc << TAG_SHIFT)) == ((cell_int)0x4 << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> IsFROZEN </name>
/// <overview></overview>
/// <desc>
/// <p>
/// ֤ޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline bool IsFROZEN(cell c)    { return ((cell2int(c) & ((cell_int)0xd << TAG_SHIFT)) == ((cell_int)0x4 << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> IsDAT </name>
/// <overview>ΥDATɤĴ٤ޤ</overview>
/// <desc>
/// <p>
/// ΥDATɤĴ٤ޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> DATʤtrue򡢤Ǥʤfalse֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline bool IsDAT(cell c)       { return ((cell2int(c) & ((cell_int)0xc << TAG_SHIFT)) == ((cell_int)0x8 << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> IsINT </name>
/// <overview>ΥINTɤĴ٤ޤ</overview>
/// <desc>
/// <p>
/// ΥINTɤĴ٤ޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> INTʤtrue򡢤Ǥʤfalse֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline bool IsINT(cell c)       { return ((cell2int(c) & ((cell_int)0xf << TAG_SHIFT)) == ((cell_int)T_INT << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> IsFLO </name>
/// <overview>ΥFLOɤĴ٤ޤ</overview>
/// <desc>
/// <p>
/// ΥFLOɤĴ٤ޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> FLOʤtrue򡢤Ǥʤfalse֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline bool IsFLO(cell c)       { return ((cell2int(c) & ((cell_int)0xf << TAG_SHIFT)) == ((cell_int)T_FLO << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> IsCHR </name>
/// <overview>ΥCHRɤĴ٤ޤ</overview>
/// <desc>
/// <p>
/// ΥCHRɤĴ٤ޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> CHRʤtrue򡢤Ǥʤfalse֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline bool IsCHR(cell c)       { return ((cell2int(c) & ((cell_int)0xf << TAG_SHIFT)) == ((cell_int)T_CHR << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> IsSTG </name>
/// <overview>ΥSTGɤĴ٤ޤ</overview>
/// <desc>
/// <p>
/// ΥSTGɤĴ٤ޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> STGʤtrue򡢤Ǥʤfalse֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline bool IsSTG(cell c)       { return ((cell2int(c) & ((cell_int)0xf << TAG_SHIFT)) == ((cell_int)T_STG << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> char_int </name>

/// <overview> ???饹</overview>
/// <desc>
/// <p>
/// ???饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef unsigned short char_int;
/// </body></classdef>


/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> PTR2c </name>
/// <overview> ݵΥؤΥݥ󥿤PTRդΥޤ </overview>
/// <desc>
/// <p>
/// ݵΥؤΥݥ󥿤PTRդΥޤ 
/// </p>
/// </desc>
/// <args> core_p֥ȤϤޤ</args>
/// <retval> cell֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>c2PTR</see>
/// <body>
inline cell PTR2c(core_p p)          { P5("PTR2c");   return int2cell(core_p2int(p)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> STR2c </name>
/// <overview>ޤϷΥꥢֹ椫STRդΥޤ</overview>
/// <desc>
/// <p>
/// (type)ޤϷΥꥢֹ(tserial)STRդΥޤ
/// </p>
/// </desc>
/// <args> type֥Ȥޤtserial֥ȤϤޤ</args>
/// <retval> cell֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>c2STR</see>
/// <body>
inline cell STR2c(const type *p)     { P5("STR2c*");  return int2cell(p->GetSerialNo() | ((cell_int)T_STR  << TAG_SHIFT)); }
inline cell STR2c(tserial serial)    { P5("STR2c");   return int2cell(     serial      | ((cell_int)T_STR  << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> VAR2c </name>
/// <overview>ޤϷΥꥢֹ椫VARդΥޤ</overview>
/// <desc>
/// <p>
/// (type)ޤϷΥꥢֹ(tserial)VARդΥޤ
/// </p>
/// </desc>
/// <args> type֥Ȥޤtserial֥ȤϤޤ</args>
/// <retval> cell֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>c2VAR</see>
/// <body>
inline cell VAR2c(const type *p)     { P5("VAR2c*");  return int2cell(p->GetSerialNo() | ((cell_int)T_VAR  << TAG_SHIFT)); }
inline cell VAR2c(tserial serial)    { P5("VAR2c");   return int2cell(     serial      | ((cell_int)T_VAR  << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> FSTR2c </name>
/// <overview>ޤϷΥꥢֹ椫FSTRդΥޤ</overview>
/// <desc>
/// <p>
/// (type)ޤϷΥꥢֹ(tserial)FSTRդΥޤ
/// </p>
/// </desc>
/// <args> type֥Ȥޤtserial֥ȤϤޤ</args>
/// <retval> cell֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>c2FSTR</see>
/// <body>
inline cell FSTR2c(const type *p)    { P5("FSTR2c*"); return int2cell(p->GetSerialNo() | ((cell_int)T_FSTR << TAG_SHIFT)); }
inline cell FSTR2c(tserial serial)   { P5("FSTR2c");  return int2cell(     serial      | ((cell_int)T_FSTR << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> FVAR2c </name>
/// <overview>ޤϷΥꥢֹ椫FVARդΥޤ</overview>
/// <desc>
/// <p>
/// (type)ޤϷΥꥢֹ(tserial)FVARդΥޤ
/// </p>
/// </desc>
/// <args> type֥Ȥޤtserial֥ȤϤޤ</args>
/// <retval> cell֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>c2FVAR</see>
/// <body>
inline cell FVAR2c(const type *p)    { P5("FVAR2c*"); return int2cell(p->GetSerialNo() | ((cell_int)T_FVAR << TAG_SHIFT)); }
inline cell FVAR2c(tserial serial)   { P5("FVAR2c");  return int2cell(     serial      | ((cell_int)T_FVAR << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> INT2c </name>
/// <overview>INTդΥޤ</overview>
/// <desc>
/// <p>
/// (mint)INTդΥޤ
/// </p>
/// </desc>
/// <args> mint֥ȤϤޤ</args>
/// <retval> cell֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>c2INT</see>
/// <body>
inline cell INT2c(mint val)          { P5("INT2c");   return int2cell( ((cell_int)val & NTAG_MASK) | ((cell_int)T_INT  << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> FLO2c </name>
/// <overview>¿FLOդΥޤ</overview>
/// <desc>
/// <p>
/// ¿(mfloat)FLOդΥޤ
/// </p>
/// </desc>
/// <args> mfloat֥ȤϤޤ</args>
/// <retval> cell֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>c2FLO</see>
/// <body>
inline cell FLO2c(mfloat val)        { P5("FLO2c");   return int2cell( ((*(cell_int*)(&val) + ((cell_int)1<<(TAG_WIDTH-1)))>> TAG_WIDTH) | ((cell_int)T_FLO  << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> CHR2c </name>
/// <overview>ʸCHRդΥޤ</overview>
/// <desc>
/// <p>
/// ʸ(mchar)CHRդΥޤ
/// </p>
/// </desc>
/// <args> mchar֥ȤϤޤ</args>
/// <retval> cell֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>c2CHR</see>
/// <body>
inline cell CHR2c(mchar val)         { P5("CHR2c");   return int2cell( (cell_int)val | ((cell_int)T_CHR  << TAG_SHIFT)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> STG2c </name>
/// <overview>ʸޤʸ󥷥ꥢ뤫STGդΥޤ</overview>
/// <desc>
/// <p>
/// ʸޤʸ󥷥ꥢ뤫STGդΥޤ
/// </p>
/// </desc>
/// <args> ʸޤʸ󥷥ܥޤʸ󥷥ꥢϤޤ</args>
/// <retval> cell֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>c2STG</see>
/// <body>
inline cell STG2c(machine *m, const char *s)     { P5("STG2c");   return int2cell( (cell_int)(strsymbol::New(m,s)->GetSerialNo()) | ((cell_int)T_STG << TAG_SHIFT) ); }
inline cell STG2c(strsymbol *s)      { P5("STG2c");   return int2cell( (cell_int)(               s ->GetSerialNo()) | ((cell_int)T_STG << TAG_SHIFT) ); }
inline cell STG2c(sserial s)         { P5("STG2c");   return int2cell( (cell_int)(               s                ) | ((cell_int)T_STG << TAG_SHIFT) ); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2PTR </name>
/// <overview>PTRΤĤ뤫ݵΥؤΥݥ󥿤Фޤ</overview>
/// <desc>
/// <p>
/// PTRΤĤ뤫ݵΥؤΥݥ(core_p)Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> core_p֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>PTR2c</see>
/// <body>
inline core_p c2PTR(cell c)          { P5("c2PTR");  ASSERT(IsPTR(c)); return int2core_p(cell2int(c)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2STRS </name>
/// <overview>STRSΤĤ뤫鷿ΥꥢֹФޤ</overview>
/// <desc>
/// <p>
/// STRSΤĤ뤫鷿Υꥢֹ(tserial)Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> tserial֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>STRS2c</see>
/// <body>
inline tserial c2STRS(cell c)        { P5("c2STR");  ASSERT(IsSTR(c)); return              (tserial)(cell2int(c) & NTAG_MASK) ; }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2STR </name>
/// <overview>STRΤĤ뤫鷿ؤΥݥ󥿤Фޤ</overview>
/// <desc>
/// <p>
/// STRΤĤ뤫鷿(type)ؤΥݥ󥿤Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> type֥ȤؤΥݥ󥿤֤ޤ </retval>
/// <remark></remark>
/// <see>STR2c</see>
/// <body>
inline const type *c2STR(cell c)     { P5("c2STR*"); ASSERT(IsSTR(c)); return type::Serial((tserial)(cell2int(c) & NTAG_MASK)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2VARS </name>
/// <overview>VARΤĤ뤫鷿ΥꥢֹФޤ</overview>
/// <desc>
/// <p>
/// VARΤĤ뤫鷿Υꥢֹ(tserial)Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> tserial֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>VARSc2</see>
/// <body>
inline tserial c2VARS(cell c)        { P5("c2VAR");  ASSERT(IsVAR(c)); return              (tserial)(cell2int(c) & NTAG_MASK) ; }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2VAR </name>
/// <overview>VARΤĤ뤫鷿ؤΥݥ󥿤Фޤ</overview>
/// <desc>
/// <p>
/// VARΤĤ뤫鷿(type)ؤΥݥ󥿤Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> type֥ȤؤΥݥ󥿤֤ޤ </retval>
/// <remark></remark>
/// <see>VAR2c</see>
/// <body>
inline const type *c2VAR(cell c)     { P5("c2VAR*"); ASSERT(IsVAR(c)); return type::Serial((tserial)(cell2int(c) & NTAG_MASK)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2STRSorVARS </name>
/// <overview>STR⤷VARΤĤ뤫鷿ΥꥢֹФޤ</overview>
/// <desc>
/// <p>
/// STR⤷VARΤĤ뤫鷿Υꥢֹ(tserial)Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> tserial֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline tserial c2STRSorVARS(cell c)  { P5("c2STRorVAR");  ASSERT(IsSTR(c) || IsVAR(c)); return              (tserial)(cell2int(c) & NTAG_MASK) ; }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2STRorVAR </name>
/// <overview>STR⤷VARΤĤ뤫鷿ؤΥݥ󥿤Фޤ</overview>
/// <desc>
/// <p>
/// STR⤷VARΤĤ뤫鷿(type)ؤΥݥ󥿤Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> type֥ȤؤΥݥ󥿤֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline const type *c2STRorVAR(cell c){ P5("c2STRorVAR*"); ASSERT(IsSTR(c) || IsVAR(c)); return type::Serial((tserial)(cell2int(c) & NTAG_MASK)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2INT </name>
/// <overview>INTΤĤ뤫Фޤ</overview>
/// <desc>
/// <p>
/// INTΤĤ뤫(mint)Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> mint֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>INT2c</see>
/// <body>
inline mint   c2INT(cell c)          { P5("c2INT");  ASSERT(IsINT(c)); return (mint)(cell2int(c) << 4) >> 4; }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2FLO </name>
/// <overview>FLOΤĤ뤫¿Фޤ</overview>
/// <desc>
/// <p>
/// FLOΤĤ뤫¿(mfloat)Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> mfloat֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>FLO2c</see>
/// <body>
inline mfloat c2FLO(cell c)          { P5("c2FLO");  ASSERT(IsFLO(c)); cell_int tmp = (cell2int(c) << TAG_WIDTH); return *(mfloat *)&tmp; }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2CHR </name>
/// <overview>FLOΤĤ뤫ʸФޤ</overview>
/// <desc>
/// <p>
/// FLOΤĤ뤫ʸ(mchar)Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> mchar֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>CHR2c</see>
/// <body>
inline mchar  c2CHR(cell c)          { P5("c2CJR");  ASSERT(IsCHR(c)); return (char_int)cell2int(c); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2STG </name>
/// <overview>STGΤĤ뤫ʸФޤ</overview>
/// <desc>
/// <p>
/// STGΤĤ뤫ʸФޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> ʸ֤ޤ </retval>
/// <remark></remark>
/// <see>STG2c</see>
/// <body>
inline char * c2STG(cell c)          { P5("c2STG"); ASSERT(IsSTG(c)); return strsymbol::Serial(cell2int(c) & NTAG_MASK)->GetString(); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> c2STGS </name>
/// <overview>STGΤĤ뤫ʸΥꥢֹФޤ</overview>
/// <desc>
/// <p>
/// STGΤĤ뤫ʸΥꥢֹ(sserial)Фޤ
/// </p>
/// </desc>
/// <args> cell֥ȤϤޤ</args>
/// <retval> sserial֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see>STGS2c</see>
/// <body>
inline sserial c2STGS(cell c)        { P5("c2STG"); ASSERT(IsSTG(c)); return (sserial)(cell2int(c) & NTAG_MASK); }
/// </body></funcdef>

std::ostream& operator<<(std::ostream& os, cell c);

} // namespace lilfes

#endif // __cell_h
