/* $Id: hash.h,v 1.3 2004/04/23 09:05:16 yusuke Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */

//
///  <ID>$Id: hash.h,v 1.3 2004/04/23 09:05:16 yusuke Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>hash.h</name>
//
///  <overview>
///  <jpn>ϥå</jpn>
///  <eng>Hash routines </eng>
///  </overview>

// Usage:
//
// class HashTable<T> : provide hash table of class T's pointer
// class T must have following functions:
//  char *GetKey(void)
//
// T *HashTable<T>::Add(T *)
//      Adds datum to the hash table. Return NULL if successful.
// T *HashTable<T>::Find(char *)
//      Finds datum on the hash table. return NULL if the data is not found.
// unsigned GetNData()
//      Returns how many data are on the table.
// unsigned GetTableSize()
//      Returns the size of the hash table.


/// <notiondef>
///
/// <name> hash_overview </name>
/// <title> ϥå롼 </title>
/// 
/// <desc>
/// 
/// <p> <ref>hash.h</ref> ˤϡϥå뤿Υ饤֥꤬äƤޤ</p>
/// 
/// 
///
/// </desc>
/// <see>  </see>
/// </notiondef>
//////////////////////////////////////////////////////////////////////////////
#ifndef __hash_h
#define __hash_h

#include "lconfig.h"
#include "errors.h"
#include <iostream>

namespace lilfes {

class FSP;

#ifdef PROFILE
#if PROFILE >= 2
#define PROFILE_HASH
#endif
#endif



//////////////////////////////////////////////////////////////////////////////
//
// class Pair
//
/// <classdef>
/// <name> Pair</name>

/// <overview>ͤȤˤ饹</overview>
/// <desc>
/// <p>
/// ͤȤޤ
/// </p>
/// </desc>
/// <see></see>

/// <body>

template <class T1, class T2>
struct Pair
{
	T1 a;
	T2 b;

	Pair() { }
	Pair(const T1 & ia, const T2 & ib) : a(ia), b(ib) { }


};
/// </body></classdef>


//////////////////////////////////////////////////////////////////////////////
//
// class HashTable
//

#define INITIALHASHSIZE 1024
	// Initial hash size must be value of 2^n form */

#define INTTABLEUSAGEMAXDEF   3
	// Expand hash table if (TABLEUSAGEMAX/16*100)% of the table is used
#define STRTABLEUSAGEMAXDEF   4
	// Expand hash table if (TABLEUSAGEMAX/16*100)% of the table is used
#define FSPTABLEUSAGEMAXDEF   4
	// Expand hash table if (TABLEUSAGEMAX/16*100)% of the table is used


/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> IntegerHash </name>

/// <overview>IntegerǤϥå륯饹</overview>
/// <desc>
/// <p>
/// 
/// 
/// </p>
/// </desc>
/// <see></see>
/// <body>

template <class Tobj>
class IntegerHash
{
	Tobj **table;
	unsigned tablesize;
  /// ϥåơ֥Υ
	unsigned ndata;
  /// ǼƤǡʥͤΥڥ
	unsigned usagemax;
  /// ϥåơ֥λѾ
#ifdef PROFILE_HASH
	const char *name;
	int add, col;
#endif

public:
		IntegerHash(const char *iname = "", unsigned inisize = INITIALHASHSIZE, unsigned max = INTTABLEUSAGEMAXDEF);
  /// ϥåޤ<br><var>iname</var>:ϥå̾<br>
  /// <var>inisize</var>:ơ֥ν<br>
  /// <var>max</var>:ơ֥λѸ١(max/16)*100% 
		IntegerHash(IntegerHash<Tobj> &);
		~IntegerHash();

	unsigned GetNData()     const { return ndata; }
  /// ϥåơ֥¸ߤǡʥͤΥڥˤޤ
  
	unsigned GetTableSize() const { return tablesize; }
  /// ϥåơ֥礭ޤ
	Tobj *Add(Tobj *data);
  /// ϥå˥ǡɲäޤƱĤΤ¸ߤɲäޤ
  /// <br>֤
  /// <br>ƱĤΤ¸ߤƤ -> Υ֥ȤؤΥݥ
  /// <br>ƱĤΤ¸ߤʤä -> NULL
	Tobj *AddOrReplace(Tobj *data);
  /// ϥå˥ǡɲäޤƱĤΤ¸ߤ֤ޤ
  /// <br>֤
  /// <br>ƱĤΤ¸ߤƤ -> Υ֥ȤؤΥݥ
  /// <br>ƱĤΤ¸ߤʤä -> NULL

        Tobj *Find(ulong Key) const;
  /// Ϳ줿бǡޤõоõ֥ȤؤΥݥ󥿤򡢾õ٤ǡĤʤäNULL֤ޤ
	Tobj *Delete(ulong Key);
  /// ϥå夫ǡõޤˤϥϤޤõоõ֥ȤؤΥݥ󥿤򡢾õ٤ǡĤʤäNULL֤ޤ
	Tobj *Delete(Tobj *data);
  /// ϥå夫ǡõޤˤϥǡؤΥݥ󥿤Ϥޤ
  
//	unsigned GetIndex(Tobj *data);

	Tobj *Pick(int index) const { return table[index]; }
  /// ϥåơ֥뤫ǡޤǤϤʤơ֥Υǥå˼ޤ
	void ClearTable() { 
		for( uint i=0; i<GetTableSize(); i++ )
		{
			delete Pick(i);
		}
	ndata = 0; memset(table, 0, tablesize*sizeof(Tobj *)); }
  /// ϥå˳ǼƤǡƾõޤ

protected:
	static int hash(ulong key);
  /// ϥåؿǤ<var>key</var>Ȥޤ
	void ExpandTable();
  /// ơ֥륵ĥޤ2ܤˤʤޤ
};
/// </body></classdef>




#define HashTable StringHash /* obsolete form */
/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> StringHash </name>

/// <overview>StringǤϥå륯饹</overview>
/// <desc>
/// <p>
/// 
/// 
/// </p>
/// </desc>
/// <see></see>

/// <body>
template <class Tobj> 
class StringHash
{
	Tobj **table;
	unsigned tablesize;
	unsigned ndata;
	unsigned usagemax;
#ifdef PROFILE_HASH
	const char *name;
	int add, col;
#endif

public:
		StringHash(const char *iname = "", unsigned inisize = INITIALHASHSIZE, unsigned max = STRTABLEUSAGEMAXDEF);
		StringHash(StringHash<Tobj> &);
		~StringHash();

	unsigned GetNData()     const { return ndata; }
	unsigned GetTableSize() const { return tablesize; }

	Tobj *Add(Tobj *data);
	Tobj *AddOrReplace(Tobj *data);
	Tobj *Find(const char *Key) const;
	Tobj *Delete(const char *Key);
	Tobj *Delete(Tobj *data);

//	unsigned GetIndex(Tobj *data);

	Tobj *Pick(int index) const { return table[index]; }

	void ClearTable() { 
		for( uint i=0; i<GetTableSize(); i++ )
		{
			delete Pick(i);
		}
	ndata = 0; memset(table, 0, tablesize*sizeof(Tobj *)); }

protected:
	static int hash(const char *key);
	void ExpandTable();
};
/// </body></classdef>





/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> HSPHash </name>

/// <overview>HSPǤϥå륯饹</overview>
/// <desc>
/// <p>
/// 
/// 
/// </p>
/// </desc>
/// <see></see>

/// <body>
template <class Tobj> 
class FSPHash
{
	Tobj **table;
	unsigned tablesize;
	unsigned ndata;
	unsigned usagemax;
#ifdef PROFILE_HASH
	const char *name;
	int add, col;
#endif

public:
		FSPHash(const char *iname, unsigned inisize = INITIALHASHSIZE, unsigned max = FSPTABLEUSAGEMAXDEF);
		FSPHash(FSPHash<Tobj> &);
		~FSPHash();

	unsigned GetNData()     const { return ndata; }
	unsigned GetTableSize() const { return tablesize; }

	Tobj *Add(Tobj *data);
	Tobj *Find(FSP Key) const;

//	unsigned GetIndex(Tobj *data);

	Tobj *Pick(int index) const { return table[index]; }

	void ClearTable() { 
		for( uint i=0; i<GetTableSize(); i++ )
		{
			delete Pick(i);
		}
	ndata = 0; memset(table, 0, tablesize*sizeof(Tobj *)); }

protected:
	static int hash(FSP key);
	void ExpandTable();
};
/// </body></classdef>


//////////////////////////////////////////////////////////////////////////////
//
// class VarArray
//
/// <classdef>
/// <name> VarArray </name>

/// <overview>Ĺ</overview>
/// <desc>
/// <p>
/// ǿѤǤΰ褬­ʤʤä鼫ưŪ˳ݤޤκݡ̤٤˳ݤޤ
/// ̤ȤΤϣΤ٤ʲ褫˰ˤܤǤ
/// </p>
/// </desc>
/// <see></see>

/// <body>
#define VARINDEX_GROWSTEP	128

template <class T>
class VarArray
{
	T **arrs;
	T *nextp;
	uint size;
	static uint growstep;		// 1) Must be declared for each type
								// 2) Must be 2^n form (2, 4, 8, 16 ... )
	static uint growbits;		// 3) Must be 2^growbits = growstep = growmask+1
	static uint growmask;

public:
	VarArray();
  /// VarArrayΥ֥Ȥޤǿ0Ǥ
	VarArray(const VarArray<T> &);
  
	~VarArray();

	uint GetSize() const { return size; }
  /// ߤǿޤ
	T &operator[](uint i) { ASSERT( i < size ); return arrs[i>>growbits][i&growmask]; }
	const T &operator[](uint i) const { ASSERT( i < size ); return arrs[i>>growbits][i&growmask]; }
	T &Next() { if( (size & (growstep-1)) == 0 ) Resize(size); size++; return *(nextp++); }
	void Push(const T &c) { Next() = c; }
  /// Ǥɲäޤ
	T &Pop() { T &ret = operator[](size-1); size--; return ret; }
  /// ǤФޤ
	uint GetLimit(uint i) const { return (i|growmask)+1; }
  /// iܤǤѤˡݤƤ٤ǿ֤ޤ㡧32ĤǤݤȤˡܤǤĤˤϡ128ǿݤƤʤȤʤ򻲾ȡ
	void Resize(uint i);
};
/// </body></classdef>


template <class T>
VarArray<T>::VarArray() { arrs = NULL; nextp = NULL; size = 0; }


template <class T>
VarArray<T>::VarArray(const VarArray<T> &v) 
{ 
	if( v.arrs == NULL ) 
	{ 
		arrs = NULL; 
		nextp = NULL; 
		size = 0; 
	} 
	else {
		size = v.size;
#if 0
	std::cout << "VarArray copy constructor" << std::endl;
	std::cout << "growmask = " << growmask << std::endl;
	std::cout << "size = " << size << std::endl;
	std::cout << "((size+growmask)>>growbits) = " << ((size+growmask)>>growbits) << std::endl;
	std::cout << "(((size+growmask)>>growbits)+VARINDEX_GROWSTEP-1)&~(VARINDEX_GROWSTEP-1) = " << ((((size+growmask)>>growbits)+VARINDEX_GROWSTEP-1)&~(VARINDEX_GROWSTEP-1)) << std::endl;
#endif
		uint arrssize = (((size+growmask)>>growbits)+VARINDEX_GROWSTEP-1)&~(VARINDEX_GROWSTEP-1);
		arrs = new T *[arrssize];
		for( uint i=0; i<((size+growmask)>>growbits); i++ )
		{
			arrs[i] = new T[growstep];
			memcpy(arrs[i], v.arrs[i], sizeof(T)*growstep);
		}
		nextp = arrs[((size+growmask)>>growbits)-1] + (size&growmask);
	}
}

template <class T>
VarArray<T>::~VarArray() 
{ 
	ASSERT(size >= 0);
//	std::cout << "size = " << size << "  ss = " << ((size+growmask)>>growbits) << "growmask = " << growmask << std::endl;
	for( uint j=0; j<((size+growmask)>>growbits); j++) 
		delete[] arrs[j]; 
	delete[] arrs; 
}

template <class T>
void VarArray<T>::Resize(uint i) 
{ 
	uint ii = i >> growbits;
	if( (ii & (VARINDEX_GROWSTEP - 1)) == 0 )
	{
		T **newarrs = new T *[ii+VARINDEX_GROWSTEP];
		if( arrs != NULL )
		{
			memcpy(newarrs, arrs, (size >> growbits) * sizeof(T *));
			delete[] arrs;
		}
		arrs = newarrs;
	}
	arrs[ii] = nextp = new T[growstep];
}

//////////////////////////////////////////////////////////////////////////////
//
// class VarArrayIterator
//
/// <classdef>
/// <name> VarArrayIterator </name>

/// <overview></overview>
/// <desc>
/// <p>
/// 
/// 
/// </p>
/// </desc>
/// <see></see>

/// <body>
template <class T>
class VarArrayIterator
{
	VarArray<T> &arr;
	T *p;
	T *limit;
	int limitptr;
public:
	VarArrayIterator(VarArray<T> &iarr) : arr(iarr) { Jump(0); }
	VarArrayIterator(VarArray<T> &iarr, int idx) : arr(iarr) { Jump(idx); }
	~VarArrayIterator() { }

	operator T *() { return p; }
	T *operator ->() { return p; }
	T *operator++()    { if( ++p >= limit ) Jump(limitptr); return p; }
	T *operator++(int) { T *ret = p; if( ++p >= limit ) Jump(limitptr); return ret; }
	VarArrayIterator<T>& operator+=(int i) { p+=i; if( p >= limit ) Jump(limitptr + (p-limit)); return *this; }
	T &operator[](int i) { if( p+i < limit ) return p[i]; else return arr[limitptr + ((p+i)-limit)]; }

	void Jump(int addr);
	int GetIndex() { return limitptr - (limit-p); }
};
/// </body></classdef>


template <class T>
void VarArrayIterator<T>::Jump(int addr)
{
	p = &(arr[addr]);
	limitptr = arr.GetLimit(addr);
	limit = p + (limitptr - addr);
}


//////////////////////////////////////////////////////////////////////////////
//
// class Queue
/// <classdef>
/// <name> Queue </name>

/// <overview>塼Ԥˤޤ</overview>
/// <desc>
/// <p>
/// 
/// 
/// </p>
/// </desc>
/// <see></see>

/// <body>
#define QUEUE_INISIZE	1024
template <class T>
class Queue
{
	T *list;
	int read, write, size;
	static T invalid;
	
public:
	Queue(int isize = QUEUE_INISIZE);
  /// <var>isize</var>Ǥ륭塼ޤ
	~Queue();

	void Enqueue(T data);
  /// 塼˥ǡɲäޤ
	T Dequeue();
  /// 塼ǡФޤ
	void FlushAll();
  /// 塼ˤޤäƤǡõޤ
	bool IsEmpty() { return read==write; }
  /// 塼ɤĴ٤ޤʤtrue򡢤Ǥʤʤfalse֤ޤ
};
/// </body></classdef>



//////////////////////////////////////////////////////////////////////////////
//
// class Bitmap
//
/// <classdef>
/// <name> Bitmap </name>

/// <overview></overview>
/// <desc>
/// <p>
/// 
/// 
/// </p>
/// </desc>
/// <see></see>

/// <body>
class Bitmap
{
	unsigned size;
	int32 *ar;
	
public:
			 Bitmap(unsigned is);
			 Bitmap(const Bitmap &p);
			~Bitmap() { delete[] ar; }
	Bitmap & operator =(const Bitmap &);


	void Set(unsigned b)   { ASSERT( size > b ); ar[b/32] |=   (int32)1<<(b%32); }
	void Reset(unsigned b) { ASSERT( size > b ); ar[b/32] &= ~((int32)1<<(b%32)); }
	bool Test(unsigned b) const { ASSERT( size > b ); return ar[b/32] & ((int32)1<<(b%32)) ? true : false; }
	void Merge(const Bitmap &b);

	bool IsAllZero();

	bool Ident(const Bitmap &b);
  /// ˻ꤵ줿Bitmap ֥ <var>b</var> ȤʬƱĴ٤ޤ
  /// <br>Ʊʤ<var>true</var>򤽤Ǥʤ<var>false</var>֤ޤ

	void Output(std::ostream &o);
};
/// </body></classdef>


//////////////////////////////////////////////////////////////////////////////
//
// class Int
//
/// <classdef>
/// <name> Int </name>

/// <overview></overview>
/// <desc>
/// <p>
/// Υ饹Ǥ
/// 
/// </p>
/// </desc>
/// <see></see>

/// <body>
class Int
{
	int i;

public:
	Int() { }
	Int(int ii) : i(ii) { }
  /// ֥Ȥꡢ<var>ii</var>Ǽޤ
	operator int &() { return i;}
	operator const int &() const { return i;}
	int GetKey() { return i;}
  /// ʬȤ֤ͤޤ
};
/// </body></classdef>

} // namespace lilfes

#endif // __hash_h
