/* $Id: initial.h,v 1.2 2004/02/08 06:35:52 mak Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */
//
///  <ID>$Id: initial.h,v 1.2 2004/02/08 06:35:52 mak Exp $</ID>
//
///  <COLLECTION>MakLib Code Library</COLLECTION>
//
///  <name>initial.h</name>
//
///  <overview>
///  <jpn>/λ</jpn>
///  <eng>Initialization and Termination</eng>
///  </overview>

#ifndef __initial_h
#define __initial_h

#include "lconfig.h"

namespace lilfes {
	
/// <notiondef>
///
/// <name> initial_overview </name>
/// <title> /λ롼 </title>
/// 
/// <desc>
/// 
/// <p> <ref>initial.h</ref> ˤϡץεư佪λ˽Ԥ碌뤿Υ饤֥꤬äƤޤ</p>
/// <ul>
/// <li> ⥸塼󥯤ǡΥ⥸塼ɬפʽ/λνԤ碌뤳ȤǤޤ
/// <li> /λνǤޤ̾襪֥ȤΥ󥹥ȥ饯/ǥȥ饯ȤäǤ
///      λ꤬¾ԲǽǤ
/// <li> /λδ֤˵㳰ªǤޤ
/// </ul>
/// <p>ȤϲΥץ</p>
/// 
/// <samp>
/// #include "initial.h"<br>
/// <br>
/// int main()<br>
/// {<br>
/// <ref>Initializer</ref>::performAll();<br>
/// <br>
/// ... (ץ)
/// <br>
/// <ref>Terminator</ref>::performAll();<br>
/// }<br>
/// <br>
/// <br>
/// class InitializeHoge : private Initializer<br>
/// {<br>
/// virtual void work();<br>
///	public:<br>
/// InitializeHoge() : Initializer(100) { }<br>
/// };<br>
/// static InitializeHoge initializerobj;<br>
/// void InitializeHoge::work()<br>
/// {<br>
/// ... ()<br>
/// }<br>
/// <br>
/// class TerminateHoge : private Terminator<br>
/// {<br>
/// virtual void work();<br>
///	public:<br>
/// TerminateHoge() : Terminator(100) { }<br>
/// };<br>
/// static TerminateHoge Terminatorobj;<br>
/// void TerminateHoge::work()<br>
/// {<br>
/// ... (λ)<br>
/// }<br>
/// <br>

/// </samp>

/// </desc>
/// <see> Initializer, Terminator</see>
/// </notiondef>

////////////////////////////////////////
//
//  Base class of Initializer and Terminator
//
/// <classdef>
/// <name> InitTermBase </name>

/// <overview> <jpn>/λ١饹</jpn><eng>Base class for initialization/termination</eng> </overview>
/// <desc>
/// <jpn>
/// <p>
/// <ref>Initializer</ref> 饹 <ref>Terminator</ref> 饹ζ̤ݴ쥯饹Ǥ
/// Ƚλɬפʥ롼̲뤿˺Ƥޤ桼ľ뤳ȤϤޤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Initializer, Terminator </see>

/// <body>
class InitTermBase
{
	InitTermBase *next;
protected:
	int priority;

private:
	virtual void Work() = 0;

public:
	InitTermBase(InitTermBase **table, int ip);

	static void PerformAll(InitTermBase *table);
};
/// </body></classdef>


////////////////////////////////////////
//
//  General Initializer/Terminator
//
/// <classdef>
/// <name> Initializer </name>

/// <overview> <jpn>١饹</jpn><eng>Base class for initialization</eng> </overview>
/// <desc>
/// <jpn>
/// <p>
/// Τݥ饹ǤΥ饹ѾơWork() ˽ɬפʽ򵭽ҤƤ
/// </p>
/// <p>
/// ñ˴ؿƤ֤ʤ <ref>InitFunction</ref> Ǥ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Terminator, InitFunction </see>

/// <body>
class Initializer : private InitTermBase
{
private:
	static InitTermBase *initable;

	virtual void Work() = 0;
  /// μ¹ԻˤδؿƤФޤ
public:
	Initializer(int ip=100);
  /// ơ֥ˤνؿϿޤ
  /// ºݤν (Work() θƤӽФ)  PerformAll() ƤФޤǹԤޤ
  /// <var>priority</var> ͥͤǤͥͤΤ˽ޤ
  /// Ʊ̤ͥΤΤʣäϽǤ
	static void PerformAll();
  /// ơ֥Ͽ줿٤ƤνؿͥͤξΤ˼¹Ԥޤ
};
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> Terminator </name>

/// <overview> <jpn>λ١饹</jpn><eng>Base class for initialization</eng> </overview>
/// <desc>
/// <jpn>
/// <p>
/// λΤݥ饹ǤΥ饹ѾơWork() ˽λɬפʽ򵭽ҤƤ
/// </p>
/// <p>
/// ñ˴ؿƤ֤ʤ <ref>TermFunction</ref> Ǥ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Initializer, TermFunction </see>

/// <body>

class Terminator : private InitTermBase
{
private:
	static InitTermBase *trmtable;

	virtual void Work() = 0;
  /// λμ¹ԻˤδؿƤФޤ
public:
	Terminator(int ip=100);
  /// λơ֥ˤνλؿϿޤ
  /// ºݤνλ (Work() θƤӽФ)  PerformAll() ƤФޤǹԤޤ
  /// <var>priority</var> ͥͤǤͥͤ礭Τ˽λޤ
  /// Ʊ̤ͥΤΤʣäϽǤ
	static void PerformAll();
  /// λơ֥Ͽ줿٤Ƥνλؿͥͤ礭Τ˼¹Ԥޤ
};
/// </body></classdef>


////////////////////////////////////////
//
//  Initializer/Terminator calls function
//
/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> InitFunction </name>

/// <overview> <jpn>ؿƤӽФ饹</jpn><eng>Initialization function caller</eng> </overview>
/// <desc>
/// <jpn>
/// <p>
/// Initializer Ѿ줿饹Ǥ Work() Ȥƻꤵ줿ؿƤӽФޤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Initializer, TermFunction </see>

/// <body>

class InitFunction : private Initializer 
{ 
	void (*func)();
	virtual void Work(); 
#ifdef DEBUG
	char *file;
#endif
public: 
	InitFunction(void (*f)(), int ip=100);
  /// ơ֥ˤνؿϿޤ
  /// ºݤν Work() Ǥϡꤵ줿ؿ <var>f</var> ƤӽФޤ<var>f</var> ϰʤ
  /// void ֤褦ʴؿǤʤФޤ<var>priority</var> Τ˼¹Ԥޤ
}; 
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> TermFunction </name>

/// <overview> <jpn>λؿƤӽФ饹</jpn><eng>Initialization function caller</eng> </overview>
/// <desc>
/// <jpn>
/// <p>
/// Terminator Ѿ줿饹Ǥλ Work() Ȥƻꤵ줿ؿƤӽФޤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Terminator, InitFunction </see>

/// <body>

class TermFunction : private Terminator
{ 
	void (*func)();
	virtual void Work(); 
#ifdef DEBUG
	char *file;
#endif
public: 
	TermFunction(void (*f)(), int ip=100);
  /// λơ֥ˤνؿϿޤ
  /// ºݤνλ Work() Ǥϡꤵ줿ؿ <var>f</var> ƤӽФޤ<var>f</var> ϰʤ
  /// void ֤褦ʴؿǤʤФޤ<var>priority</var> 礭Τ˼¹Ԥޤ
}; 
/// </body></classdef>


#if 0
////////////////////////////////////////
//
//  Initializer/Terminator making a instance
//
/// <classdef>
/// <name> InitTermInstance </name>

/// <overview>
///<jpn></jpn>
///<eng></eng>
///</overview>
/// <desc>
/// <jpn>
/// <p>
/// 
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Terminator, InitFunction </see>

/// <body>

template <class T>
class InitTermInstance
{
	class InitInstance : private Initializer
	{
		T *&p;
		virtual void Work() { p = new T; }
	public: 
		InitInstance(T *&p, int ip) : Initializer(ip) { }
	}; 
	class TermInstance : private Terminator
	{
		T *&p;
		virtual void Work(); 
	public: 
		TermInstance(T *&p, int ip);
	}; 

	
};
/// </body></classdef>
#endif

} // namespace lilfes 

#endif
