/* $Id: lexer.h,v 1.1 2004/02/08 15:08:40 mak Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */

///  <ID>$Id: lexer.h,v 1.1 2004/02/08 15:08:40 mak Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>lexer.h</name>
//
///  <overview>
///  <jpn>lexer_t ̃wb_t@C</jpn>
///  <eng>Header-file for lexer_t</eng>
///  </overview>

#ifndef __lexer_h
#define __lexer_h

namespace lilfes {

class lilfesFlexLexer;

class lexer_t {
	lilfesFlexLexer *l;

public:
	lexer_t() : l(NULL) { }
	lexer_t(const lexer_t &);
	lexer_t(lilfesFlexLexer *il);
	lexer_t(std::istream *is, const char *filename, int iproginput = 0 );
	~lexer_t();

//	operator bool() const { return l != NULL; } 
	bool operator !() const { return l == NULL; } 
	operator lilfesFlexLexer *() { return l; }
	operator const lilfesFlexLexer *() const { return l; }
	lilfesFlexLexer& operator*() { return *l; }
	const lilfesFlexLexer& operator*() const { return *l; }
	lilfesFlexLexer* operator->() { return l; }
	const lilfesFlexLexer& operator->() const { return *l; }
};

} // namespace lilfes

#endif // __lexer_h
