/* $Id: lstring.h,v 1.3 2004/02/08 07:36:49 mak Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */

///  <ID>$Id: lstring.h,v 1.3 2004/02/08 07:36:49 mak Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>lstring.h</name>
//
///  <overview>
///  <jpn>ʸ롼</jpn>
///  <eng>string operation routine </eng>
///  </overview>

/// <notiondef>
/// <name> lstring_overview </name>
/// <title> ʸ롼 </title>
/// 
/// <desc>
/// 
/// <p> <ref>lstring.h</ref>string 饹μǤǤʸ˴ؤ뤵ޤޤʥ᥽åɤѰդƤޤlstringȤlight stringάǡڤưܻؤƺƤޤ<br>
/// </p>
/// </desc>
/// <see> </see>
/// </notiondef>

#ifndef __lstring_h
#define __lstring_h

#include "lconfig.h"

#include <string.h>
#include <iostream>

namespace lilfes {

/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> lstring </name>

/// <overview>ʸ 饹</overview>
/// <desc>
/// <p>
/// ʸ󥯥饹Ǥʸ˴ؤ᥽åɤѰդƤޤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
class lstring
{
	char *str;
	
public:
	lstring() { str = NULL; }
	lstring(const char *s);
	lstring(const lstring &s);
	explicit lstring(char c, int repeat = 1);
	~lstring();

	bool IsNull() const { return str == NULL; }
  /// ȤNULLɤĴ٤ޤ
	operator char *() const { return str; }
  /// ÷ʸѴޤ
  
	lstring &operator =(const lstring &l);
	lstring &operator =(const char *s);
  /// ʸޤʸ󤬥ԡޤ
	char &operator[](int i) { return str[i]; }
  /// iܤʸޤ
	friend lstring operator+(const lstring &a, const lstring &b);
	friend lstring operator+(const char *a, const lstring &b);
	friend lstring operator+(const lstring &a, const char *b);
  /// ʸ礷ޤ
  
	char *GetKey() { return str; } // for use in HashTable
  /// ʸ֤ޤHashTableǻȤѰդƤޤ
  
#ifndef NO_IOSTREAM
	friend std::ostream& operator<<(std::ostream& os, const lstring &l) { return os << (char *)(l.operator char *()); }
  /// ʸϤޤ
#endif
};
/// </body></classdef>


// gokan overload function
/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> strlen </name>
/// <overview>ʸĹ</overview>
/// <desc>
/// <p>
/// ʸĹޤ
/// </p>
/// </desc>
/// <args> ʸϤޤ</args>
/// <retval> ʸĹ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline int strlen(const lstring &a) 
{ return ::strlen(a.operator char *()); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> strcpy </name>
/// <overview>ʸ󥳥ԡ</overview>
/// <desc>
/// <p>
/// <var>a</var>Ȥ<var>s</var>˥ԡޤ
/// </p>
/// </desc>
/// <args> ԡȥԡʸϤޤ</args>
/// <retval> ԡʸ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline char *strcpy(char *s, const lstring &a) 
{ return ::strcpy(s, a.operator char *()); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> strcmp </name>
/// <overview>ʸ</overview>
/// <desc>
/// <p>
/// ʸΤӤޤ
/// </p>
/// </desc>
/// <args> ӤʸϤޤ</args>
/// <retval> ʸƱʤ飰a&lt;bʤ-1a&gt;bʤ1֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline int strcmp(const lstring &a, const lstring &b)
{ return ::strcmp(a.operator char *(), b.operator char *()); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> strcmp </name>
/// <overview>ʸ</overview>
/// <desc>
/// <p>
/// ʸӤޤ
/// </p>
/// </desc>
/// <args> ӤʸϤޤ</args>
/// <retval> ʸƱʤ飰a&lt;bʤ-1a&gt;bʤ1֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline int strcmp(const char *a, const lstring &b) 
{ return ::strcmp(a, b.operator char *()); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> strcmp </name>
/// <overview>ʸ</overview>
/// <desc>
/// <p>
/// ʸӤޤ
/// </p>
/// </desc>
/// <args> ӤʸϤޤ</args>
/// <retval>  ʸƱʤ飰a&lt;bʤ-1a&gt;bʤ1֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline int strcmp(const lstring &a, const char *b) 
{ return ::strcmp(a.operator char *(), b); }
/// </body></funcdef>

inline int strlen(const char *a) { return ::strlen(a); }
inline int strcmp(const char *a, const char *b) { return ::strcmp(a,b); }
inline char * strcpy(char *a, const char *b) { return ::strcpy((char *)a,b); }

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> int2lstr </name>
/// <overview>ʸѴ</overview>
/// <desc>
/// <p>
/// ͤlstring֥ȤѴޤ
/// </p>
/// </desc>
/// <args> intͤϤޤ</args>
/// <retval> lstring֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
lstring int2lstr(int i);
/// </body></funcdef>

} // namespace lilfes

#endif // __lstring_h
