/* $Id: module.h,v 1.4 2004/08/08 04:00:18 yusuke Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */

///  <ID>$Id: module.h,v 1.4 2004/08/08 04:00:18 yusuke Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>module.h</name>
//
///  <overview>
///  <jpn>⥸塼</jpn>
///  <eng>module </eng>
///  </overview>

// added by kaityo 
// for module

#ifndef __module_h
#define __module_h

#include "lconfig.h"

namespace lilfes {

class feature;
class type;
class machine;

} // namespace lilfes

#include "hash.h"
#include "lstring.h"
#include "initial.h"

namespace lilfes {

/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> module </name>
/// <overview> ⥸塼 </overview>
/// <desc>
/// <p>
/// ʣηޤȤưΥ饹Ǥ<BR>
/// <pre>
///         ⥸塼A                    ⥸塼B                     ⥸塼C
/// |------------------------|--    |------------------------|--    |------------------------|
/// |      interface       |  --  |      interface       |  --  |      interface       |
/// |                        |    ->|                        |    ->|                        |
/// |                        |  --  |                        |  --  |                        |
/// |------------------------|--    |------------------------|--    |------------------------|
/// |      implement       |      |      implement       |      |      implement       |
/// |                        |      |                        |      |                        |
/// |                        |      |                        |      |                        |
/// |------------------------|      |------------------------|      |------------------------|
/// </pre>
/// <BLOCKQUOTE>
/// οޤˤơ⥸塼C⥸塼Bimport⥸塼B⥸塼AimportƤȤޤΤȤAinterfaceˤΤB鸫ޤAimplementˤΤBϸޤƱͤˡBinterfaceˤΤC鸫ޤBimplementˤΤCϸޤ󡣤ޤAinterfaceˤΤC鸫ޤ<BR>
/// </BLOCKQUOTE>
/// <pre>
///         ⥸塼A
/// |------------------------|--
/// |      interface       |  --
/// |                        |    --
/// |                        |  -- |
/// |------------------------|--   |         ⥸塼C                       ⥸塼D
/// |      implement       |     |   |------------------------|--     |------------------------|
/// |                        |     --->|      interface       |  --   |      interface       |
/// |                        |         |                        |    -->|                        |
/// |------------------------|         |                        |  --   |                        |
///                                    |------------------------|--     |------------------------|
///         ⥸塼B            --->|       implement      |       |      implement       |
/// |------------------------|--   |   |                        |       |                        |
/// |      interface       |  -- |   |                        |       |                        |
/// |                        |    --   |------------------------|       |------------------------|
/// |                        |  --
/// |------------------------|--
/// |      implement       |
/// |                        |
/// |                        |
/// |------------------------|
/// </pre>
/// <BLOCKQUOTE>
/// οޤˤơ⥸塼Cinterface˥⥸塼Aimport졢⥸塼Cimplement˥⥸塼Bimport졢˥⥸塼Dinterface˥⥸塼CimportƤȤޤ<BR>
/// ΤȤCˤȤäusableʤΤϡCȤ٤ƤAinterfaceΤΤBinterfaceΤΤǤ<BR>
/// DCinterfaceAinterfaceΤΤޤBinterfaceΤΤϸޤ<BR>
/// CreexportlistˤAꡢnoexportlistˤBޤ<BR>
/// Cprevious module()DAprevious moduleCBprevious moduleDȤʤޤ
/// </BLOCKQUOTE>
/// </p>
/// </desc>
/// <see></see>
/// <body>
class module			// Τ module_hash
{
public:
	enum new_module_type
          /// Υ⥸塼κǤ
          { 
		NMT_NONE						= 0, /// ???
		NMT_INCLUDE						= 1, 
		NMT_ENSURE						= 2, 
		NMT_ENSURE_INITIAL				= 3, 
		NMT_ENSURE_IN_PROG				= 4, 
		NMT_CONSULT						= 5, 
		NMT_READ_LILFES					= 6, 
		NMT_READ_LILFES_WITH_PREFIX		= 7, 
		NMT_READ_MODULE					= 8, 
		NMT_INITIALIZE					= 9, 
		NMT_BUILTIN						= 10,
		NMT_ENSURE_WITHOUT_BUILTIN		= 11,
		NMT_ENSURE_WITHOUT_BUILTIN_IN_PROG		= 12,
		NMT_COMMAND						= 13,
		NMT_CREATE_MODULE				= 14
	};

protected:
	lstring name;
  /// Υ⥸塼̾Ǥ
	lstring defname;
  /// ⥸塼ʤΥǥե̾Ǥ
	StringHash<type> hash;
  /// ̾б뷿Υϥå塣
	VarArray<module *> reexportlist;
  /// ⥸塼椫ƵŪɤ߹ޤ줿⥸塼ΥꥹȤǤ
  /// Υ⥸塼뤬 import 줿Ȥˤäimport ޤ
	VarArray<module *> noexportlist;
  /// ⥸塼椫ƵŪɤ߹ޤ줿⥸塼ΥꥹȤǤ
  /// Υ⥸塼뤬 import Ƥ⤤äimport ޤ
	module *prev_module;
  /// ƵŪɤ߹ޤ줿ȤΡɤ߹߸ʿơˤΥ⥸塼Ǥ
	bool InterfaceMode;   //It means this module is in interface declaration or not now.
  /// Υ⥸塼ɤ߹ǤȤˡinterfaceɤ߹Ǥ뤫implementeɤ߹Ǥ뤫ɽޤԤʤtrueԤʤfalseˤʤޤ
	bool ExtendableMode;
  /// Υ⥸塼ƤηˤĤ¾Υ⥸塼 subtype ɤɽޤ
	new_module_type nmt;
  /// Υ⥸塼뤬ɤΤ褦ˡɤ߹ޤ줿ȤȤɽnew_module_typeѿǤ
	module** first_import_modules; // modules which are imported as the builtin
  /// ۤΤimport⥸塼ΥꥹȤǤ
	static StringHash<module> modulelist_hash;
  /// ⥸塼̾⥸塼ΥϥåǤ

	static module *m_user;
  /// Ȥ߹ߥ⥸塼롣LiLFeS򥳥ޥɥ饤ǻȤ硢ޥɥ饤󤫤Ϥ⥸塼ȤưޤΥ⥸塼ΤȤǤ
	static module *m_core;
  /// Ȥ߹ߥ⥸塼롣bottomʤɤΤ٤ƤξǻȤ뷿Ƥ⥸塼Ǥ
	static module *m_builtin;
  /// Ȥ߹ߥ⥸塼롣Ȥ߹߽ҸƤ⥸塼Ǥ
	static module *m_directive;
  /// Ȥ߹ߥ⥸塼롣⥸塼ɤ߹ߤ椹뷿Ƥ⥸塼Ǥ
	static module *m_current;
  /// λɤ߹Υ⥸塼Ǥ

	static lstring module_prefix;
  /// ɤ߹⥸塼̾ɤ߹߸Ʊ⥸塼̾Ȥʤʤ褦ˡΥ⥸塼ƬˤĤƬǤ㤨"__"դޤ

private:
	static void init();
  /// Ͻ򤷤ޤ
	static void term();
  /// λ򤷤ޤ
	static void init2();
  /// Ͻ򤷤ޤ¾νθ˼¹Ԥޤ
	static InitFunction IF;
	static InitFunction IF2;
	static TermFunction TF;
  /// init,init2,termƤ֤˺äХ륪֥ȤǤ

public:
	explicit module(const char *iname, new_module_type inmt = NMT_NONE, bool Extendable = false);
  /// <var>iname</var>⥸塼̾<br>
  /// <var>inmt</var><br>
  /// <var>Extendable</var>extendable(Υ⥸塼ƤηˤĤ¾Υ⥸塼 subtype )ɤ<br>
	~module() { }

	bool IsRegistered() { return *name; }
  /// Υ⥸塼뤬⥸塼ꥹȤϿƤ뤫ɤĴ٤ޤ
	void Register(const char *str = NULL);
  /// ⥸塼⥸塼ꥹȤɲäޤλΥ⥸塼̾ޤޤ
	const char *GetKey() const { return name; }
  /// ϥåѤΥ᥽åɤǤȤ֤̾ޤ
	const char *GetName() const { return name; }
  /// ̾ޤ
	const char *GetDefName() const { return defname; }
  /// ⥸塼ʤΥǥե֤̾ޤ
	void Add(type *t) { if( ! IsRegistered() ) Register(); hash.AddOrReplace(t); }
  /// <var>t</var>򤽤Υ⥸塼ɲäޤ
	void Delete(type *t);
  /// <var>t</var>򤽤Υ⥸塼뤫ޤ
	type *Search(const char *str) const { ASSERT(this != NULL); return hash.Find(str); }
  /// ̾<var>str</var>Ǥ뷿ޤ
        const feature *SearchFeature(const char *str) const;
  /// ̾<var>str</var>Ǥޤ
	bool IsExporting(const type *t) const;
  /// <var>t</var>exportʾ򻲾ȡˤƤ뤫ɤĴ٤ޤ
	bool IsUsable(const type *t) const;
  /// <var>t</var>Υ⥸塼usableʾ򻲾ȡˤɤĴ٤ޤ
	void SetInterfaceMode(bool flag) { InterfaceMode = flag;}
  /// InterfaceModeʤΥ⥸塼ɤ߹ǤȤˡinterfaceɤ߹Ǥ뤫ɤˤꤷޤ
	bool GetInterfaceMode(void) const { return InterfaceMode; }
  /// Υ⥸塼ɤ߹ǤȤˡinterfaceɤ߹Ǥ뤫implementɤ߹Ǥ뤫Ĵ٤ޤԤʤtrueԤʤfalse֤ޤ
	void SetExtendableMode(bool flag) { ExtendableMode = flag;}
  /// ExtendableModeʤΥ⥸塼ƤηˤĤ¾Υ⥸塼 subtype ɤˤꤷޤ
	bool GetExtendableMode(void) const { return ExtendableMode; }
  ///  ExtendableModeʤΥ⥸塼ƤηˤĤ¾Υ⥸塼 subtype ɤˤɤĴ٤ޤ
	void SetFirstImport(module** imports);
  /// ⥸塼<var>imports</var>first_import_modulesˤޤ
	module** ExportList(void) const;
  /// reexportlistˤ⥸塼ޤ
	module** NoExportList(void) const;
  /// noexportlistˤ⥸塼ޤ
	new_module_type GetModuleType() { return nmt; }
  /// Υ⥸塼Υפޤ
	void SetPrevModule(module *mod) { prev_module = mod; }
  /// ⥸塼<var>mod</var>򤽤Υ⥸塼ɤ߹߸(previous module)ꤷޤ
	module * GetPrevModule() { return prev_module; }
  /// ƵŪɤ߹ޤ줿ȤΡɤ߹߸ʿơˤΥ⥸塼ޤ

	static void SetModulePrefix(lstring prefixname) { module_prefix = prefixname; }
  /// lstring<var>prefixname</var>module_prefixˤޤ
	static const lstring & GetModulePrefix(void) {return module_prefix;} 
  /// module_prefixޤ
	void Import(module *mod, bool reexport);
  /// Υ⥸塼ˡ⥸塼<var>mod</var>importޤ<var>reexport</var>trueʤ餽Υ⥸塼ɤ߹߸鸫ޤfalseʤ鸫ޤ
	void Import(module *mod) { Import(mod, GetInterfaceMode()); }
	void Finish();
  /// Υ⥸塼ɤ߹ߤäȤˡ⥸塼ɤ߹ߥ󥸥˸ƤФޤ<BR>
  /// Υ⥸塼줿Ƥӹ߸importޤ

	static void SetCurrentModule(module *mod);
  /// ⥸塼<var>mod</var>ɤ߹Υ⥸塼ꤷޤ
	static module *SearchModule(const char *name) { module *m = modulelist_hash.Find(module_prefix + name); return m ? m : modulelist_hash.Find(name); }
  /// ̾б⥸塼ޤ
	static module *CoreModule() { return m_core; }
  /// m_core⥸塼ޤ
	static module *BuiltinModule() { return m_builtin; }
  /// m_builtin⥸塼ޤ
	static module *UserModule() { return m_user; }
  /// m_user⥸塼ޤ
	static module *DirectiveModule() { return m_directive; }
  /// m_directive⥸塼ޤ
	static module *CurrentModule() { return m_current; }
  /// ɤ߹Υ⥸塼ޤ
	static void UseCurrentModule();
  /// Υ⥸塼뤬Ƥ뤫ɤĴ٤ơƤʤХ顼ФơdefnameϿޤ
	static module* module::new_module(machine &m, const char *biname, lstring modname, new_module_type nmt, module *prev = NULL, module** importlist = NULL);
  /// ⥸塼ޤǤƱ⥸塼뤬¸ߤФΥ⥸塼̵֤пޤ
  /// <var>m</var>ݵ<br>
  /// <var>biname</var>顼Ȥˤɤǥ顼ɽޤ<br>
  /// <var>modname</var>̾̾ϥեΥ⥸塼̾ɤ߹˷ޤޤ<br>
  /// <var>nmt</var>⥸塼κ<br>
  /// <var>prev</var>Υ⥸塼ɤ߹߸Υ⥸塼<br>
  /// <var>importlist</var>import⥸塼<br>
  
//Added by kaityo for debug

	void ShowList(void);
  /// Υ⥸塼˴ޤޤ뷿ΰɽޤ
};
/// </body></classdef>


} // namespace lilfes


#endif // __module_h
