/* $Id: option.h,v 1.11 2005/06/16 03:11:07 yusuke Exp $
 *
 *    Copyright (c) 1998-2000, Takaki Makino
 *
 *    You may distribute this file under the terms of the Artistic License.
 */

///  <ID>$Id: option.h,v 1.11 2005/06/16 03:11:07 yusuke Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>option.h</name>
//
///  <overview>
///  <jpn>ޥɥ饤LiLFeSץǻѤǤ륪ץ˴ؤ롼</jpn>
///  <eng>??? </eng>
///  </overview>

#ifndef	__option_h
#define __option_h

#include "lconfig.h"
#include "lstring.h"
#include "structur.h"

namespace lilfes {

////////////////////////////////////////
/// <classdef>
/// <name> lilfes_flag </name>
/// <overview> ץ</overview>
/// <desc>
/// <p>
/// lilfes_flag󥹥󥹣ĤĤΥץ㤨-rȤ-fȤˤбޤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
class lilfes_flag
{
protected:
	uchar opt;
  /// ûץ̾Ǥopt'\0'λϡûץ̾¸ߤʤȤȤǤ 
	lstring name;
  /// Ĺץ̾Ǥ
	lstring usage;
  /// ȤǤ

	static StringHash<lilfes_flag> flagCollection;
  /// Ĺץ̾(name) бlilfes_flag֥ȤΥϥåǤ
	static lilfes_flag* flagmap[];
  /// ûץ̾(opt) бlilfes_flag֥ȤΥơ֥Ǥ

public:
	lilfes_flag(const char *iname, const char *iusage) : opt('\0'), name(iname), usage(iusage) { flagCollection.Add(this); }
  /// <var>iname</var>Ĺץ̾<br>
  /// <var>iusage</var>Ȥ<br>

	lilfes_flag(uchar iopt, const char *iname, const char *iusage) : opt(iopt), name(iname), usage(iusage) { flagmap[opt] = this; flagCollection.Add(this); }
  /// <var>iopt</var>ûץ̾<br>
  /// <var>iname</var>Ĺץ̾<br>
  /// <var>iusage</var>Ȥ<br>
        virtual ~lilfes_flag() { }

	const char *GetKey() { return name; }
  /// ϥåѤΥ᥽åɤǤȤ֤̾ޤ
	virtual int GetIntVal() { return 0; }
  /// <ref>lilfes_int_flag</ref>ʤͤΰȤ뤳ȤǤ륪ץ󤫤顢ͤ벾۴ؿǤ
	virtual void SetIntVal(int) { }
  /// <ref>lilfes_int_flag</ref>ʤͤΰȤ뤳ȤǤ륪ץˡͤꤹ벾۴ؿǤ
	virtual const char *GetStrVal() { return 0; }
  /// ʸΰȤ뤳ȤǤ륪ץ󤫤顢ʸ벾۴ؿǤ
	virtual void SetStrVal(const char *) { }
  /// ʸΰȤ뤳ȤǤ륪ץˡʸꤹ벾۴ؿǤ
	virtual bool SetFlagFromFSP(FSP f) = 0;
  /// ΥץFSP֥<var>f</var>򥪥ץΰȤϤޤȤƻȤtrueȤʤfalse֤ޤLiLFeSץ椫ϤȤ˻Ȥޤ
	virtual bool SetFlagFromString(const char *s) = 0;	// return true if the string is consumed
  /// Υץʸ<var>s</var>򥪥ץΰȤϤޤȤƻȤtrueȤʤfalse֤ޤ
	virtual FSP GetFlagToFSP(machine &m) { return FSP(m); }
  /// ¤ΰȤ뤳ȤǤ륪ץ󤫤顢¤벾۴ؿǤݵ<var>m</var>ξ¤ޤ
	virtual void PrintUsage(std::ostream &o);
  /// ΥץλȤɽޤ

	static void ParseOptions(machine *mach, int argc, char **argv);
  /// ǽϤ줿ץʸϤŬڤlilfes_flag֥ȤͤϤ᥽åɡ

	static int ExecOptions(machine &mach);
  /// -eץǻꤵ줿ޥɤϤ¹Ԥ᥽åɡ

	static lilfes_flag * Search(const char *s) { return flagCollection.Find(s);}
  /// Ĺץ̾<var>s</var>бlilfes_flag֥Ȥޤ
	static lilfes_flag * GetFlagMap(uchar c) { return flagmap[c];}
  /// ûץ̾<var>c</var>бlilfes_flag֥Ȥޤ
};
/// </body></classdef>

////////////////////////////////////////
/// <classdef>
/// <name> lilfes_int_flag </name>
/// <overview> ͤΰȤ뤳ȤǤ륪ץΥ饹</overview>
/// <desc>
/// <p>
/// ץΰȤͤȤ뤳ȤǤ褦ʥץΥ饹Ǥ<br>
/// 㡧-d80
/// </p>
/// </desc>
/// <see></see>
/// <body>
class lilfes_int_flag : public lilfes_flag
{
	int val;
	bool is_changeable;

public:
	lilfes_int_flag(char *iname, int ival, bool flag, const char *iusage) : lilfes_flag(iname, iusage), val(ival), is_changeable(flag) { }
  /// <var>iname</var>Ĺץ̾<br>
  /// <var>ival</var>ץΰν<br>
  /// <var>iusage</var>Ȥ<br>
  
	lilfes_int_flag(uchar iopt, char *iname, int ival, bool flag, const char *iusage) : lilfes_flag(iopt, iname, iusage), val(ival), is_changeable(flag) { }
  /// <var>iopt</var>ûץ̾<br>
  /// <var>ival</var>ץΰν<br>
  /// <var>iusage</var>Ȥ<br>
  
	virtual int GetIntVal() { return val; }
  /// ץΰˤޤ
  
	virtual void SetIntVal(int i) { val = i; }
  /// ץΰ<var>i</var>ꤷޤ
  
	virtual bool SetFlagFromFSP(FSP f);
  /// ???
	virtual bool SetFlagFromString(const char *s);
  /// Υץʸs򥪥ץΰȤϤޤ ȤƻȤtrueȤʤfalse֤ޤ
	virtual FSP  GetFlagToFSP(machine &m) { return FSP(m, (mint)val); }
  /// ???
};
/// </body></classdef>

/// <classdef>
/// <name> lilfes_quiet_flag </name>
/// <overview> ץ'q',"quiet"ǻȤ륯饹</overview>
/// <desc>
/// <p>
/// 'q',"quiet"ץ󤬻ꤵ줿ȤΥ饹Υ֥ȤȤޤ<br>
/// </p>
/// </desc>
/// <see></see>
/// <body>
class lilfes_quiet_flag : public lilfes_flag
{
public:
  lilfes_quiet_flag(char *iname, const char *iusage) : lilfes_flag(iname, iusage) { }
  lilfes_quiet_flag(uchar iopt, char *iname, const char *iusage) : lilfes_flag(iopt, iname, iusage) { }
    
  virtual bool SetFlagFromFSP(FSP);
  virtual bool SetFlagFromString(const char *) {
#ifdef PROFILE
    profiler::SetQuiet(true);
#endif // PROFILE
    return true;
  }
  virtual FSP GetFlagToFSP(machine &m);
};
/// </body></classdef>

/// <classdef>
/// <name> lilfes_help_flag </name>
/// <overview> ץ'h',"help"ǻȤ륯饹</overview>
/// <desc>
/// <p>
/// 'h',"help"ץ󤬻ꤵ줿ȤΥ饹Υ֥ȤȤޤ<br>
/// </p>
/// </desc>
/// <see></see>
/// <body>
class lilfes_help_flag : public lilfes_flag
{
private:
  static int help_flag;

public:
  lilfes_help_flag(char *iname, const char *iusage) : lilfes_flag(iname, iusage) { }
  lilfes_help_flag(uchar iopt, char *iname, const char *iusage) : lilfes_flag(iopt, iname, iusage) { }
  
  virtual bool SetFlagFromFSP(FSP) { 
    RUNERR("LiLFeS Flag \"help\" is read-only");
    return false; 
  };
  virtual bool SetFlagFromString(const char *s); 
  virtual FSP GetFlagToFSP(machine &m); 
  
  static int optcmp(const void *a, const void *b);
  /// qsortѤƥץ̾򥽡Ȥ뤿Υץ̾Ӵؿ

  static void printHelp(std::string &str);

  static int getHelpFlag() { return help_flag; }
};
/// </body></classdef>

/// <classdef>
/// <name> lilfes_load_flag </name>
/// <overview> ץ'l',"load"ǻȤ륯饹</overview>
/// <desc>
/// <p>
/// 'l',"load"ץ󤬻ꤵ줿ȤΥ饹Υ֥ȤȤޤ<br>
/// </p>
/// </desc>
/// <see></see>
/// <body>
class lilfes_load_flag : public lilfes_flag
{
private:
  module::new_module_type nmt;
  static std::vector< std::string > stov;
  static std::vector< module::new_module_type > ston;

public:
  lilfes_load_flag(char *iname, const char *iusage, module::new_module_type inmt) : lilfes_flag(iname, iusage), nmt(inmt) { }
  lilfes_load_flag(uchar iopt, char *iname, const char *iusage, module::new_module_type inmt) : lilfes_flag(iopt, iname, iusage), nmt(inmt) { }
  
  virtual bool SetFlagFromFSP(FSP) { 
    RUNERR("LiLFeS Flag \"load\" is read-only");
    return false; 
  }
  virtual bool SetFlagFromString(const char *s); 
  virtual FSP GetFlagToFSP(machine &m);

  static void pushNewModule( const std::string& name, module::new_module_type type ) {
    stov.push_back( name );
    ston.push_back( type );
  }

  static int getNumLoadModule() { return stov.size(); }
  static std::string& getLoadModule( size_t i ) { return stov[ i ]; }
  static module::new_module_type getLoadModuleType( size_t i ) { return ston[ i ]; }
};
/// </body></classdef>

/// <classdef>
/// <name> lilfes_path_flag </name>
/// <overview> ץ"include-path"ǻȤ륯饹</overview>
/// <desc>
/// <p>
/// "include-path"ץ󤬻ꤵ줿ȤΥ饹Υ֥ȤȤޤ<br>
/// </p>
/// </desc>
/// <see></see>
/// <body>
class lilfes_path_flag : public lilfes_flag
{
public:
	lilfes_path_flag(char *iname, const char *iusage) : lilfes_flag(iname, iusage){ }
	lilfes_path_flag(uchar iopt, char *iname, const char *iusage) : lilfes_flag(iopt, iname, iusage) { }

	virtual bool SetFlagFromFSP(FSP);
	virtual bool SetFlagFromString(const char *s); 
	virtual FSP GetFlagToFSP(machine &m); 
};
/// </body></classdef>

/// <classdef>
/// <name> lilfes_arg_flag </name>
/// <overview> ץ'a' ǻȤ륯饹</overview>
/// <desc>
/// <p>
/// 'a' ץ󤬻ꤵ줿ȤΥ饹Υ֥ȤȤޤ<br>
/// </p>
/// </desc>
/// <see></see>
/// <body>
class lilfes_arg_flag : public lilfes_flag
{
private:
  static std::vector< std::string > comargs;

public:
  lilfes_arg_flag(char *iname, const char *iusage) : lilfes_flag(iname, iusage){ }
  lilfes_arg_flag(uchar iopt, char *iname, const char *iusage) : lilfes_flag(iopt, iname, iusage) { }

  virtual bool SetFlagFromFSP(FSP){ 
    RUNERR("LiLFeS Flag \"argv\" is read-only");
    return false; 
  }
  virtual bool SetFlagFromString(const char *){ return false; }
  virtual FSP GetFlagToFSP(machine &m); 

  static bool SetFlagFromStringArray(int argc, char **argv);

  static int getArgc() { return comargs.size(); }
  static const std::string& getArgv( size_t i ) { return comargs[ i ]; }
  static const std::vector< std::string >& getArgs() { return comargs; }

};
/// </body></classdef>

/// <classdef>
/// <name> lilfes_eval_flag </name>
/// <overview> ץ'e' ǻȤ륯饹</overview>
/// <desc>
/// <p>
/// 'e' ץ󤬻ꤵ줿ȤΥ饹Υ֥ȤȤޤ<br>
/// </p>
/// </desc>
/// <see></see>
/// <body>
class lilfes_eval_flag : public lilfes_flag
{
private:
  static std::vector< std::string > cmd_list;

public:
  lilfes_eval_flag(char *iname, const char *iusage) : lilfes_flag(iname, iusage){ }
  lilfes_eval_flag(uchar iopt, char *iname, const char *iusage) : lilfes_flag(iopt, iname, iusage) { }

  virtual bool SetFlagFromFSP(FSP){ 
    RUNERR("LiLFeS Flag \"eval\" is read-only");
    return false; 
  }
  virtual bool SetFlagFromString(const char *);
  virtual FSP GetFlagToFSP(machine &m); 

  static const std::vector< std::string >& getCommandList() { return cmd_list; }
};
/// </body></classdef>

/// <classdef>
/// <name> lilfes_package_dir_flag </name>
/// <overview> ץ"package-dir" ǻȤ륯饹</overview>
/// <desc>
/// <p>
/// "package-dir" ץ󤬻ꤵ줿ȤΥ饹Υ֥ȤȤޤ<br>
/// </p>
/// </desc>
/// <see></see>
/// <body>
class lilfes_package_dir_flag : public lilfes_flag
{
public:
  static std::string LILFES_PACKAGE_DIR;

public:
  lilfes_package_dir_flag(char *iname, const char *iusage) : lilfes_flag(iname, iusage) { }

  virtual bool SetFlagFromFSP(FSP);
  virtual bool SetFlagFromString(const char *);
  virtual FSP GetFlagToFSP(machine &m); 

};
/// </body></classdef>

} // namespace lilfes

#endif	// __option_h
