/* $Id: outform.h,v 1.2 2004/02/08 06:35:52 mak Exp $
 *
 *    Copyright (c) 1997, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */
///  <ID>$Id: outform.h,v 1.2 2004/02/08 06:35:52 mak Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>outform.h</name>
//
///  <overview>
///  <jpn>¤򸫤䤹쥤Ȥɽ뤿 롼 </jpn>
///  <eng>outform routine </eng>
///  </overview>
#ifndef __outform_h
#define __outform_h

#include "lconfig.h"
#include "lstring.h"
#include "basic.h"

namespace lilfes {

////////////////////////////////////////
//
//  class outform
//
//  Used for formatting the feature structure.
/// <classdef>
/// <name> outform </name>
/// <overview> ¤쥤Ȥɽޤ</overview>
/// <desc>
/// <p>
/// outform饹ȤʸǤ쥤Ȥ򤹤뤿˶֤ˤʬȾѥڡƤޤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
class outform
{
	int x, y;
	std::string *data;
	
public:
		outform();
		outform( std::string s );
		outform( lstring s );
		outform( const char *s );
  /// <var>s</var>ɽȤʸ<br>
		outform( const outform &o );
  /// outform<var>o</var>ƱȤoutform֥Ȥޤ
		~outform();

	outform& operator=(const outform &);
  /// Ȥ򥳥ԡޤ
	void SetString( std::string s );
  /// Ȥʸ򥻥åȤޤ
	void AddAtBottom(const outform &);
  /// ʸɲäޤΰ֤Ϻˤʤޤ
	void AddAtRight(const outform &);
  /// ʸɲäޤ岼ΰ֤濴ˤޤ
        void AddAtRightTop(const outform &);
  /// ʸɲäޤ夬·ޤ
	void AddAtRightBottom(const outform &);
  /// ʸɲäޤ·ޤ
	void SurroundByBracket(const char * lt, const char * lm, const char * lb, const char * lx, const char * rt, const char * rm, const char * rb, const char * rx);
  /// ʸ  lt,lm,lb,lx,rt,rm,rb,rx  ǰϤߤޤ<br>
  /// Ȥ0Ԥλϡ<br>
  /// Ȥ1ԤλϡlxrxǰϤߤޤ<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;Ȥhogehogeǡlx = [ , rx = ] ΤȤȤ[hogehoge]Ѥޤ<br>
  /// Ȥ2԰ʾλϡlt,lm,lb,rt,rm,rbǰϤߤޤ<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;Ȥ<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;hogehoge1<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;hogehoge2<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;hogehoge3<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;hogehoge4<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;ǡlt = [ , lm = | , lb = &lt;, rt = ] ,rm = | , rb = &gt;, ΤȤȤ<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[hogehoge1]<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|hogehoge2|<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|hogehoge3|<br>
  /// &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;hogehoge4&gt;<br>
  /// Ѥޤ<br>
  /// <br>
	bool IsEmpty() { return y==0; }
  /// Ȥ餫ɤĴ٤ޤ
	friend std::ostream& operator<<(std::ostream&, outform);
  /// Ƥɽޤ
};
/// </body></classdef>

} // namespace lilfes

#endif // __outform_h
