//
///  <ID>$Id: profile.h,v 1.7 2005/06/16 03:11:07 yusuke Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>profile.h</name>
//
///  <overview>
///  <jpn>ץեʬ</jpn>
///  <eng>Profiling routines </eng>
///  </overview>

#ifndef __profile_h
#define __profile_h

#include "lconfig.h"
#include "errors.h"

#ifdef PROFILE

#ifdef PASSIVE_PROFILE
#include <time.h>
#include <signal.h>
#endif

namespace lilfes {

/// <notiondef>
///
/// <name> profile_overview </name>
/// <title> ץե󥰥롼 </title>
/// 
/// <desc>
/// 
/// <p> <ref>profile.h</ref> ˤϡץΥ롼䡢νˤ֤¬뤿Υ饤֥꤬äƤޤ</p>
/// 
/// <p>֤¬ꤹˤϡΤ褦ˤơؿʤɤ P<var>x</var> ֥ȤϤߤǤ<br>
/// <var>x</var>Ͼܺ٤ǡ飵ޤǤޤ</p>
/// <samp>void f()<br>
/// {<br>
/// P1("function f");<br>
/// ... /* ؿ */<br>
/// }</samp><br>
///
/// <p>Τ褦ʵҤˤꡢprof Υ֥ P1 Ƥޤǡʤξϴؿ f() äƤФޤ)
/// λ֤˥å "function f" ȤƷ¬ޤƱ˥å̾ prof Ƿ¬줿֤Ʊ˥å̾profbase˼ưŪ߷פơץνλ˰ˤʤäƽϤޤ</p>
/// <p>ʤϥץե뤷ʤȤɤĴ٤롼ʤ褯Ȥ饤ؿʤɡˤϡ
/// P3 Τ褦˾ܺ٤ꤷ prof Ȥޤѥ -DPROFILE=3 Ȼꤹȡ
/// ܺ٤ 3 ʲΤΤ¬ꤵ졢4 ʾΤΤ¸ߤʤΤƱͤ˰ޤ
/// </desc>
/// <see> prof </see>
/// </notiondef>

/////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> timebase </name>

/// <overview>֤ɽñ̤Υ饹</overview>
/// <desc>
/// <p>
/// ץե餬֤ɽΥ饹Ǥ
/// </p>
/// </desc>
/// <see>prof</see>

/// <body>

typedef double timebase;

/// </body></classdef>


/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> profbase </name>

/// <overview>֤Ȥη¬֤򽸷פ륯饹</overview>
/// <desc>
/// <p>
/// ƥץե ˥åȤˤĤơץե餬֤ѷ׻뤿˻Ȥ륯饹Ǥ
/// 桼Υ饹ľ뤳ȤϤޤ
/// </p>
/// </desc>
/// <see>prof</see>

/// <body>

class profbase	// exporting to HashTable<profbase>
{
	unsigned long passcnt; /// ̲
	const char *name; /// ץե̾
	timebase alltime; /// 
	timebase exctime; /// 
#ifdef PASSIVE_PROFILE
	int	reentrantcnt; /// 
  /// 
#endif
	
public:
	profbase(const char *n) : passcnt(1), name(n), alltime(0), exctime(0) 
          /// <var>n</var> ȤΥץե̾λ֤Ѥ
          /// ֥Ȥޤ
          {
#ifdef PASSIVE_PROFILE
			reentrantcnt = 1;
#endif
		 }

	const char *GetKey() { return name; }
  /// ץե̾ޤhashȤưɬס
        const char *GetName() { return name; }
  /// ץե̾ޤ
	void AddTime(timebase t) { alltime += t; }
  /// ֤˻ <var>t</var> Ѥޤ
	void ExcTime(timebase t) { exctime += t; }
  /// ֤˻ <var>t</var> Ѥޤ
  
#ifdef PASSIVE_PROFILE
	void Enter() { passcnt++; reentrantcnt++; }
  /// 󥿡̲󥿤䤷ޤ
	int Leave() { return --reentrantcnt; }
  /// 󥿤1餷ޤ
#else
	void Enter() { passcnt++; }
#endif

	unsigned long GetPassCount() { return passcnt; }
			/// ̲ޤ
	timebase GetAllTime() { return alltime; }
			/// ֤ޤ
	timebase GetExcTime() { return exctime; }
			/// ֤ޤ

	std::ostream& output(std::ostream& os);
			/// Υ˥åȤˤĤƤΥץե̤Ϥޤ

	static int COMPAREFUNC pbcomp(const void *a, const void *b);
  /// ˥å̾ʸӤޤ
};

/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name>prof</name>

/// <overview>֤μ¹Ի¬ꡦλΤΥ饹</overview>
/// <desc>
/// <p>
/// <ref>profile_overview</ref>򻲾
/// 
/// </p>
/// </desc>

/// <body>

class prof
{
	timebase start_tick;
	prof *parent; /// ҤǻȤäȤγ¦prof֥ȤؤΥݥ
	profbase *my_base; /// ʬ°profbaseؤΥݥ
	static prof *current;

public:
	prof(const char *n);
  /// ̾ n Ȥץե֤Υץե򳫻Ϥޤ
	~prof();
  /// Υץե֤ΥץեλޤƱץե̾profbase֥Ȥ˻֤ûޤ
	static timebase GetTick();
  /// ߻ޤñ̤ϦsecǤ
	void AddTime(timebase t) { start_tick += t;}
  /// ϻ֤˻ <var>t</var> Ѥޤ
	friend class profiler;
  /// ץΤΥץե򰷤饹Ǥ
};

/// </body></classdef>


/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name>profuser</name>

/// <overview>LiLFeS ץޤΤΥ饹</overview>
/// <desc>
/// <p>
/// TODO(Υ饹˴ؤƤϸ̤ΩäƤ)
/// 
/// </p>
/// </desc>

/// <body>
class profuser
{
	timebase start_tick;
  ///ϻ
	profbase *my_base;
	profuser *next;
	static profuser *root;

	profuser *search_internal(const char *name);

public:
	profuser(const char *n);
	~profuser();

	const char *GetName() { return my_base->GetName(); }
	static timebase GetTick() { return prof::GetTick(); }
  /// ߻ޤñ̤ϦsecǤ
	void AddTime(timebase t) { start_tick += t;}
  /// ϻ֤˻ <var>t</var> Ѥޤ
	timebase GetTime() { return start_tick; }

	static profuser *Search(const char *name) { if( root == NULL ) return NULL; else return root->search_internal(name); }

	static profuser *GetRoot() { return root;}
	profuser *GetNext() { return next; }
	friend class profiler;
};

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name>profiler</name>

/// <overview>ΤΥץե礹륯饹</overview>
/// <desc>
/// <p>
/// ץΤΥץեޤ
/// 
/// </p>
/// </desc>

/// <body>

class profiler
{
#ifdef PASSIVE_PROFILE
#ifdef USE_TIMER_SETTIME
	timer_t timerid;
#endif
	static void SIGALRM_Handler(int);
	static struct sigaction oldact_SIGALRM;
	static const timebase tickunit;

	static int profile_block_count;
#endif
	prof *p;
	static bool quiet;

public:
	profiler();
  /// ץΥץե򳫻Ϥޤ
	~profiler();
  /// ץեη̤Ϥץեλޤ

#ifdef PASSIVE_PROFILE
	static void DisableProfiling() { profile_block_count ++; }
  /// ץեߤޤ
	static void EnableProfiling() { if( profile_block_count <= 0 ) ABORT("Bad Profiling"); profile_block_count--; }
  /// ץե¹Ԥޤ
	static bool IsProfiling() { return profile_block_count == 0; }
#else
	static void DisableProfiling() {  }
	static void EnableProfiling() {  }
	static bool IsProfiling() { return true; }
  /// DisableProfiling() ƤʤɤĴ٤ޤ
#endif
	static bool GetQuiet() { return quiet; }
	static void SetQuiet(bool flag) { quiet = flag; }
  /// <var>flag</var> trueΤȤϤޤ
};
/// <see>profbase</see>
/// </body></classdef>

#define __PROFS(s,x,l)  prof prof_##x##l(s)

#define P0(s) __PROFS(s, 0, __LINE__)
#if PROFILE + 0 >= 1
#define P1(s) __PROFS(s, 1, __LINE__)
#else
#define P1(s)
#endif
#if PROFILE + 0 >= 2
#define P2(s) __PROFS(s, 2, __LINE__)
#else
#define P2(s)
#endif
#if PROFILE + 0 >= 3
#define P3(s) __PROFS(s, 3, __LINE__)
#else
#define P3(s)
#endif
#if PROFILE + 0 >= 4
#define P4(s) __PROFS(s, 4, __LINE__)
#else
#define P4(s)
#endif
#if PROFILE + 0 >= 5
#define P5(s) __PROFS(s, 5, __LINE__)
#else
#define P5(s)
#endif

} // namespace lilfes

#else	// PROFILE

#define P0(s)
#define P1(s)
#define P2(s)
#define P3(s)
#define P4(s)
#define P5(s)

#endif

namespace lilfes {

void start_prof(const char* s);
int stop_prof(const char* s);
int total_prof(const char* s);
unsigned long total_count_prof(const char* s);

} // namespace lilfes

#endif	// __profile_h

