/* $Id: structur.h,v 1.8 2004/05/13 09:14:51 yusuke Exp $
 *
 *    Copyright (c) 1997, Makino Takaki
 *
 *    You may distribute under the terms of the Artistic License.
 *
 */

///  <ID>$Id: structur.h,v 1.8 2004/05/13 09:14:51 yusuke Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>structure.h</name>
//
///  <overview>
///  <jpn>롼</jpn>
///  <eng>routine </eng>
///  </overview>


/// <notiondef>
///
/// <name> stucture_overview </name>
/// <title> structure </title>
/// <desc>
///  structure.h
/// </desc>
/// <see>  </see>
/// </notiondef>
#ifndef __structur_h
#define __structur_h

#include "lconfig.h"
#include "cell.h"
#include "machine.h"
#include <vector>
#include <map>

namespace lilfes {

class FSP;
typedef class FSP FSPointer;

class ShareList;
class ptree;
class pprocdef;

/// <classdef>
/// <name> FSP (FSPointer) </name>
/// <overview> Feature Structure Pointer 饹</overview>
/// <desc>
/// <p>
/// LiLFeSˤ¤(Feature Structure)Υݥ(Pointer)򰷤饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
class FSP
{
	machine	*mach;
	/// оݤݵؤΥݥ󥿤ݻѿǤ
	core_p	addr;
	/// оݤΥɥ쥹ݻѿǤ

public:
	FSP(void) { mach = NULL; addr = CORE_P_INVALID; }
	/// globalѿݻƤmach̵ʥݥ󥿤оݤˤFSPointerޤ
	explicit FSP(machine *im) { mach = im; addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(VAR2c(bot)); }
	/// ҡ׾bot¤Υݥ󥿤оݤˤFSPointerޤ
	///<var>im</var>botǡɲäоݤȤʤmachineݵ饹
	explicit FSP(machine &im) { mach = &im; addr = mach->GetHP();mach->CheckHeapLimit(addr);  mach->PutHeap(VAR2c(bot)); }
	/// ҡ׾bot¤Υݥ󥿤оݤˤFSPointerޤ
	///<var>im</var>botǡɲäоݤȤʤmachineݵ饹
	
	FSP(machine *im, core_p ia) { mach = im; addr = ia; }
	///  imȥɥ쥹iaоݤˤFSPointerޤ
	/// <var>im</var> оݤݵ
	/// <var>ia</var> оݤΥɥ쥹
	FSP(machine &im, core_p ia) { mach = &im; addr = ia; }
	///  imȥɥ쥹iaоݤˤFSPointerޤ
	/// <var>im</var> оݤݵ
	/// <var>ia</var> оݤΥɥ쥹
	
	FSP(machine *im, mchar ch) { mach = im;  addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(CHR2c(ch)); }
	/// ҡ׾char¤Υɥ쥹оݤˤFSPointerޤ
	///<var>im</var> оݤݵ
	///<var>ch</var> ɲäʸǡ
	FSP(machine &im, mchar ch) { mach = &im; addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(CHR2c(ch)); }
	/// ҡ׾char¤Υɥ쥹оݤˤFSPointerޤ
	///<var>im</var> оݤݵ
	///<var>ch</var> ɲäʸǡ

	FSP(machine *im, mint i) { mach = im;  addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(INT2c(i)); }
	/// ҡ׾int¤Υɥ쥹оݤˤFSPointerޤ
	///<var>im</var> оݤݵ
	///<var>i</var> ɲäǡ
	FSP(machine &im, mint i) { mach = &im; addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(INT2c(i)); }
	/// ҡ׾int¤Υɥ쥹оݤˤFSPointerޤ
	///<var>im</var> оݤݵ
	///<var>i</var> ɲäǡ
	FSP(machine *im, mfloat d) { mach = im;  addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(FLO2c(d)); }
	/// ҡ׾float¤Υɥ쥹оݤˤFSPointerޤ
	///<var>im</var> оݤݵ
	///<var>d</var> ɲä¿ǡ
	FSP(machine &im, mfloat d) { mach = &im; addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(FLO2c(d)); }
	/// ҡ׾float¤Υɥ쥹оݤˤFSPointerޤ
	///<var>im</var> оݤݵ
	///<var>d</var> ɲä¿ǡ
	FSP(machine *im, const char *s) { mach = im;  addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(STG2c(mach,s)); }
	/// ҡ׾string¤Υɥ쥹оݤˤFSPointerޤ
	///<var>im</var> оݤݵ
	///<var>s</var> ɲäʸ󷿥ǡ
	FSP(machine &im, const char *s) { mach = &im; addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(STG2c(mach,s)); }
	/// ҡ׾string¤Υɥ쥹оݤˤFSPointerޤ
	///<var>im</var> оݤݵ
	///<var>s</var> ɲäʸ󷿥ǡ
	FSP(machine *im, cell c) { mach = im;  addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(c); }
	/// ҡ׾cΥɥ쥹оݤˤFSPointerޤ
	///<var>im</var> оݤݵ
	///<var>c</var> ɲäcellǡ
	FSP(machine &im, cell c) { mach = &im; addr = mach->GetHP(); mach->CheckHeapLimit(addr); mach->PutHeap(c); }
	/// ҡ׾cΥɥ쥹оݤˤFSPointerޤ
	///<var>im</var> оݤݵ
	///<var>c</var> ɲäcellǡ


	FSP Deref() { return FSP(mach, mach->Deref(addr) ); }
	/// addrλؤcellPTRդcell򤿤ɤäƤäơǽŪ˻ؤƤ륢ɥ쥹оݤˤFSPointerޤ
	FSP FollowNth(int i) { ASSERT(IsSTR(ReadCell())); return FSP(mach, mach->Deref(addr) + i+1); }
	/// iܤFollowȤ¤ؤFSPointer֤
	///<var>i</var>
        void VAR2STR( void );
	/// addrؤcell֥ȤVAR(ѿ)ʤСҡΰΥȥåפˤбSTRcell֥Ȥɲä,Ȥcell֥ȤǼƤɥ쥹ͤϿ줿cell֥ȤؤPPTRΥݥ󥿤Ѵ롣

	machine *GetMachine() const { return mach; }
	/// mach֤ޤ
	core_p   GetAddress() const { return addr; }
	/// addr֤ޤ
	core_p   GetAddr()    const { return addr; }
	/// addr֤ޤ

	cell     ReadCell()   const { return mach->ReadHeap(mach->Deref(addr)); }
	/// addrDerefɥ쥹cell֥Ȥޤ 
	void     WriteCell(cell c)   { mach->WriteHeap(mach->Deref(addr), c); }
	/// addrDerefɥ쥹c񤭹ߤޤ
	///<var>c</var>񤭤cellǡ
	

	// return true if the FSP has a valid address
	bool IsValid() const { return addr != CORE_P_INVALID; } // We need not check mach....
	/// addr̵ʥɥ쥹CORE_P_INVALIDǤʤTrueǤʤС̵ʥɥ쥹ʤFalse֤ޤ
	bool IsInvalid() const { return addr == CORE_P_INVALID; } // We need not check mach....
	/// addr̵ʥɥ쥹CORE_P_INVALIDǤTrueǤʤС̵ʥɥ쥹ǤʤFalse֤ޤ
	
	
	// Get the type of the root node.
	const type *GetType() const;
	/// addrDerefɥ쥹ؤ¤Υפ֤
	
	// Return true if the FSP is a leaf (i.e., it is VAR, INT, FLO, ...)
	bool IsLeaf() const { return !IsSTR(mach->ReadHeap(mach->Deref(addr))); }
	/// addrDerefɥ쥹cellΥSTR(structure)ǤFalse, ǤʤTrue֤ޤ
	
	// Return true if the FSP is a node (i.e., it is STR cell)
	bool IsNode() const { return  IsSTR(mach->ReadHeap(mach->Deref(addr))); }
	/// addrDerefɥ쥹cellΥSTR(structure)ǤTrue, ǤʤFalse֤ޤ
	
	bool IsVariable() const { return IsVAR(mach->ReadHeap(mach->Deref(addr))); }
	/// addrDerefɥ쥹cellΥVAR(ѿ)ǤTrue,ǤʤFalse֤ޤ

	bool IsFrozen() const { return IsFROZEN(ReadCell()); }
	/// ̤
	bool IsInteger() const { return IsINT(ReadCell()); }
	/// addrλؤcellΥINT()ǤTrue,ǤʤFalse֤ޤ
	bool IsFloat() const { return IsFLO(ReadCell()); }
	/// addrλؤcellΥFLO(¿)ǤTrue,ǤʤFalse֤ޤ
	bool IsChar() const { return IsCHR(ReadCell()); }
	/// addrλؤcellΥCHR(ʸ)ǤTrue,ǤʤFalse֤ޤ
	bool IsString() const { return IsSTG(ReadCell()); }
	/// addrλؤcellΥSTG(ʸ)ǤTrue,ǤʤFalse֤ޤ

	mint   ReadInteger() const { return c2INT(ReadCell()); }
	/// addrDerefɥ쥹celläƤФ֤ޤ
	mfloat ReadFloat()   const { return c2FLO(ReadCell()); }
	/// addrDerefɥ쥹cell˼¿äƤФ֤ޤ
	mchar  ReadChar()    const { return c2CHR(ReadCell()); }
	/// addrDerefɥ쥹cellʸäƤФ֤ޤ
	char * ReadString()  const { return c2STG(ReadCell()); }
	/// addrDerefɥ쥹cellʸäƤФ֤ޤ
	sserial ReadStringSN() const { return c2STGS(ReadCell()); }
	/// addrDerefɥ쥹cellʸäƤФʸΥꥢֹ֤ޤ

// return true if the FSP have a feature f
	bool CheckFeature(const feature *f) { return GetType()->GetIndex(f) != -1; }

// As their names express...
	FSP Follow(const feature *);
	/// addrξ¤f򤿤ɤä¤ؤΥݥ󥿤addr˻FSPointer֤ޤ
	FSP Follow(const type *t) { return Follow(feature::Search(t)); }
	/// tбfeature֥Ȥõaddrξ¤Τ򤿤ɤä¤ؤΥݥ󥿤addr˻FSPointer֤ޤ
	bool Coerce(const type *);
	/// פaddrؤɥ쥹ˤ¤ñ첽롣
	bool Unify(FSP);
	/// FSPointeraddrȡFSPointeraddrؤɥ쥹ˤ¤ñ첽Ԥޤ 
        bool Unify( mint i ) { return Unify( FSP( mach, i ) ); }
        bool Unify( mfloat f ) { return Unify( FSP( mach, f ) ); }
        bool Unify( const char* s ) { return Unify( FSP( mach, s ) ); }
        bool Unify( const std::string& s ) { return Unify( FSP( mach, s.c_str() ) ); }
/*	FSP Copy(machine *);*/
	FSP Copy(void) const;
	/// addrؤ¤HPؤ(ҡΰƬ)˥ԡ롣
	FSP SharedNodeList( std::map< core_p, unsigned int >& ) const;
	/// ԡ줿¤ι¤ͭ򤵤
        FSP CanonicalCopy() const;
        /// Ƥ bot  STR  VAR Ѵ륳ԡ
	FSP GetTop(void);
	/// ⤷addrλؤcellSTR(structure)ޤVAR(ѿ)ʤ顢cellηVARcellcellؤΥݥ󥿤FSPointer֤ޤINT(),FLO(¿),CHR(ʸ),STG(ʸ)ʤ餽cellؤΥݥ󥿤FSPointer֤ޤ

// serialize and unserialize
private:
        void __Serialize(std::vector<cell> &);
public:
        std::vector<cell>* Serialize() { std::vector<cell>* vec = new std::vector<cell>(); __Serialize(*vec); return vec; };
        void Serialize(std::vector<cell> &vec) { __Serialize(vec);};
	/// addrؤ¤vector<cell>Υǡ¤˳Ǽ롣
        void Serialize(std::vector<cell> *vec) { __Serialize(*vec); };
	/// addrؤ¤vector<cell>*Υǡ¤˳Ǽ롣
private:
        static std::vector<char> buffer;
        void __FSP(int s, int e, const std::vector<cell>& vec);
public:
	FSP(machine* im, const std::vector<cell> *vec) { mach = im; addr = mach->GetHP(); __FSP(0, vec->size(), *vec); };
        /// std::vector<cell>¤ҡ׾,FSPointer֤
        FSP(machine* im, const std::vector<cell> &vec) { mach = im; addr = mach->GetHP(); __FSP(0, vec.size(), vec); };
        /// std::vector<cell>¤ҡ׾,FSPointer֤
        FSP(machine &im, const std::vector<cell> *vec) { mach = &im; addr = mach->GetHP(); __FSP(0, vec->size(), *vec); };
        /// std::vector<cell>¤ҡ׾,FSPointer֤ 
        FSP(machine &im, const std::vector<cell> &vec) { mach = &im; addr = mach->GetHP(); __FSP(0, vec.size(), vec); };
        /// std::vector<cell>¤ҡ׾,FSPointer֤ 
	FSP(machine* im, const std::vector<cell> *vec, int s, int e) { mach = im; addr = mach->GetHP(); __FSP(s, e, *vec); };
        /// std::vector<cell>¤ҡ׾,FSPointer֤
        FSP(machine* im, const std::vector<cell> &vec, int s, int e) { mach = im; addr = mach->GetHP(); __FSP(s, e, vec); };
        /// std::vector<cell>¤ҡ׾,FSPointer֤
        FSP(machine &im, const std::vector<cell> *vec, int s, int e) { mach = &im; addr = mach->GetHP(); __FSP(s, e, *vec); };
        /// std::vector<cell>¤ҡ׾,FSPointer֤ 
        FSP(machine &im, const std::vector<cell> &vec, int s, int e) { mach = &im; addr = mach->GetHP(); __FSP(s, e, vec); };
        /// std::vector<cell>¤ҡ׾,FSPointer֤ 

	bool b_equiv(FSP);
    /// normalized줿¤ɤequivalent check®˹Ԥ

// Generate a ptree structure
	ptree *GeneratePTree();
	///not used

// Get arity for the predicate types
	int GetArity() const;
	/// addrDerefɥ쥹ؤ¤η(type)ܤΰνҸ췿Ǥ뤫֤ޤ
	
// miteno toorida!!!!
	outform DisplayAVM();
    /// ¤AVMɽ
	outform DisplayAVMMinimum(); // Added by mitsuisi (1999.11.30)
    /// defaultͤɽʤDisplayAVM
	outform DisplayAVM(ShareList &, bool minimum = 0, const type *deftype = bot);
	outform DisplayLiLFeS();
    /// ¤LiLFeSץɽ롣
	outform DisplayLiLFeS(ShareList &, const type *t = bot);
        std::string  DisplayLiLFeSwithoutSpaces(); // Added by mitsuisi (1999.11.30)
    /// ¤LiLFeSץɽ롣̵̤ʥڡɽʤ
	std::string  DisplayLiLFeSwithoutSpaces(ShareList &, const type *t = bot); // Added by mitsuisi (1999.11.30)
};


inline FSP FSP::Follow(const feature *f)
{
	ASSERT( this != NULL );
//	if( addr == CORE_P_INVALID || f == NULL )
//		return FSP(mach, CORE_P_INVALID);
	ASSERT( mach != NULL );

#ifdef DEBUG
	if( DEB )
		std::cout << "FollowFeature " << std::hex << cp2int(addr) << std::dec << ", " << f->GetName() << std::endl;
#endif

	return FSP(mach, mach->FollowFeature(addr, f));
}
///addrξ¤f򤿤ɤä¤ޤɬפʤСά(VAR)Ȥη(STR)ᤷꡢcoerce⤷ꤷޤ 
///<var>f</var>оݤȤʤFeature

/// <classdef>
/// <name> ShareList </name>
/// <overview> ShareList 饹</overview>
/// <desc>
/// <p>
/// LiLFeSˤƹ¤ͭ򰷤饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
class ShareList
{
public:
	struct AddrRefPair
	{
		core_p addr;
		///ݵΥɥ쥹FSPointermachHPΤѤƤ롣
		int ref;
		///addrˤĥɥ쥹FSPointerθĿ(if >=2 then structure shared)

		static int cmp(const void *a, const void *b);
		///not yet
	};
	///ɥ쥹ȤΥɥ쥹FSPointerοȤ߹碌
	
protected:
	machine *mach;
	///оݤݵǤ
	VarArray<AddrRefPair> mark;
	///Ĺarray of HeapPoint& Referencial times of the address
	VarArray<AddrRefPair> share;
	///array of Structure shared address & referential times of the shared???

public:
	ShareList() { mach = NULL; }

	const VarArray<AddrRefPair> &MarkArray() { return mark; }
	///mark֤ޤ
	const VarArray<AddrRefPair> &ShareArray() { return share; }
	///share֤ޤ

	bool AddMarkWithoutRecursion(FSP f);  // return true if shared
	/// fݵHPƱɥ쥹mark.addr˴ޤޤƤ餽mark(Ʊֹ).ref+1True֤ǤʤmarkfHPɲäref1ˤFalse֤ޤ
	///<var>f</var>оݤȤʤFSPointer
	void AddMark(FSP f);
	/// fݵHPƱɥ쥹mark.addr˴ޤޤƤ餽mark(Ʊֹ).ref+1ǤʤmarkfHPɲäref+1faddrλؤǡSTR(Structure)ʤ餽γƥǡˤĤƤAddMarkԤޤ
	///<var>f</var>оݤȤʤFSPointer
	void MakeShare();
	/// markstructure sharingСΥɥ쥹shareɲäޤ
	void MergeRef(ShareList &sl);
	/// ShareListmarkΥǡrefslΤȤ­碌ޤ
	///<var>sl</var>оݤȤʤShareList
	int SearchShare(FSP f);	// return -1 if not shared, index number (>=0) if shared
	/// fderefݵHPƱɥ쥹share.addr˴ޤޤƤ餽Arrayֹ桢Ǥʤ-1֤ޤ
	///<var>f</var> оݤȤʤFSPointer
	int GetShareCount(int idx) { return ++share[idx].ref; }
	/// shareidxܤref+1֤ޤ
	///<var>idx</var>оݤȤʤֹ
	void ClearShareCounts() { for( uint i=0; i<share.GetSize(); i++ ) { share[i].ref = 0; } }
	/// shareƣˤޤ
	int GetRefCount(FSP f);
	/// ⤷fderefƱaddressmark(.addr)ˤСmark(ֹ)ref֤ޤ¸ߤʤϣ֤ޤ
	///<var>f</var>оݤȤʤFSPointer
};

ptree *GenPTreeOfConstraint(ShareList &sl, FSP fs, const type *t, bool, bool);
/// fs??
///<var>sl</var> 
///<var>fs</var> 
///<var>t</var> 
///<var>self</var> 
///<var>feat</var> not used
ptree *GenPTreeOfClause(ShareList &sl, FSP fs);
/// fsλؤaddrDerefؤcelltypet_predʽҸ췿ˤ⤷t_means:-ˤǤФ˱ptreeʼºݤˤpclause˷֤ޤǤʤNULL֤ޤ
///<var>sl</var>sharelist
///<var>fs</var>оݤȤʤFSPointer
ptree *GenPTreeOfDescription(ShareList &sl, FSP fs, const type *t = bot);
/// fsλؤaddrDerefؤcellƤ˱ptree֤ޤ⤷slShareListfsȹ¤ͭΤСθޤ
///<var>sl</var>sharelist
///<var>fs</var>fspointser
///<var>t</var>basetype
pprocdef *GenPTreeOfDefinition(ShareList &sl, FSP fs);
/// fsλؤaddrDerefؤcellƤ˱pprocdef֤ޤ⤷celltypet_predUnifyǤʤпtypeޤ
///<var>sl</var>sharelist
///<var>fs</var>fspointer
ptree *GenPTreeOfCall(ShareList &sl, FSP fs);
/// fsλؤaddrDerefؤcellƤ˱ptree֤ޤ⤷celltypet_predUnifyǤʤпtypeޤ
///<var>sl</var>sharelist
///<var>fs</var>fspointer
ptree *GenPTreeOfGoal(ShareList &sl, FSP fs, const char *label = NULL);
/// fsλؤaddrDerefؤcelltype"is"","";""->""\+"ǤФ˱ptree֤ޤʳξGenPTreeOfCall(sl, fs)֤ޤ
///<var>sl</var>sharelist
///<var>fs</var>fspointer
///<var>label</var>
ptree *GenPTreeOfImmediateGoal(ShareList &sl, FSP fs);
/// pinterpret(fs)֤ޤ
///<var>sl</var>sharelist
///<var>fs</var>fspointer
ptree *GenPTreeOfExpression(ShareList &sl, ptree *&result, FSP fsx);
/// fsxλؤaddrDerefؤcelltype黻Built-in Predicates:黻ȡ˷subtypeǤФ˱ptree֤ޤǤʤNULL֤ޤ
///<var>sl</var>sharelist
///<var>result</var>variable tree
///<var>fsx</var>FSPointer

//////////////////////////////////////////////
//// functions for hashing vec<cell>* in STL
////
struct eqvcp
{
  bool operator() (const std::vector<cell> *v1, const std::vector<cell> *v2) const {
    return *(v1) == *(v2);
  }
};

struct hash_vcp
{
  size_t operator()(const std::vector<cell>* v) const {
    cell_int r = 0;
    std::vector<cell>::const_iterator it = v->begin(), last = v->end();
    for ( ; it != last; it++)
      r = (r << 1) ^ cell2int(*it);
    
    return size_t(r);
  }
};
  

//////////////////////////////////////////////
//// functions for hashing vec<cell> in STL
////
struct eqvc
{
  bool operator() (const std::vector<cell> &v1, const std::vector<cell> &v2) const {
    return v1 == v2;
  }
};

struct hash_vc
{
  size_t operator()(const std::vector<cell>& v) const {
    cell_int r = 0;
    std::vector<cell>::const_iterator it = v.begin(), last = v.end();
    for ( ; it != last; it++)
      r = (r << 1) ^ cell2int(*it);
  
    return size_t(r);
  }
};

} // namespace lilfes

#endif // __structur_h
