#ifndef BISON_Y_TAB_H
# define BISON_Y_TAB_H

#ifndef YYSTYPE
typedef union {
  int      ival;
  double   dval;
  char*    str;
  lilfes::type*    typeval;
  const lilfes::type *ctypeval;
  lilfes::feature* featval;
  const lilfes::feature* cfeatval;
  lilfes::module *modval;
  struct {
	  lilfes::feature *feat;
	  const lilfes::type *app;
  } appfeatval;
  lilfes::core_p   pval;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	TOK_ATOM	257
# define	TOK_FEAT	258
# define	TOK_VAR	259
# define	TOK_STARTP	260
# define	TOK_MODULENAME	261
# define	TOK_INTEGER	262
# define	TOK_STRING	263
# define	TOK_DOUBLE	264
# define	TOK_INVALID	265
# define	TOK_IS	266
# define	TOK_MOD	267
# define	TOK_EOF	268
# define	SUBSUMED_BY	269
# define	ATTR_DEF	270
# define	ATOMP	271
# define	LISTEND	272
# define	MEANS	273
# define	MACRO_DEF	274
# define	QUERY	275
# define	UMEANS	276
# define	IF_THEN	277
# define	NOT	278
# define	CMP_L	279
# define	CMP_LE	280
# define	CMP_G	281
# define	CMP_GE	282
# define	CMP_EQ	283
# define	CMP_NE	284
# define	NOT_UNIFIABLE	285
# define	BIT_OR	286
# define	BIT_AND	287
# define	INTDIV	288
# define	USIGN	289
# define	FEATURE	290


#endif /* not BISON_Y_TAB_H */
